#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """
CiMgVmVyc2lvbjogMC4xOQoKIiIiVGhlIFZlcnNpb25lZXIgLSBsaWtlIGEg
cm9ja2V0ZWVyLCBidXQgZm9yIHZlcnNpb25zLgoKVGhlIFZlcnNpb25lZXIK
PT09PT09PT09PT09PT0KCiogbGlrZSBhIHJvY2tldGVlciwgYnV0IGZvciB2
ZXJzaW9ucyEKKiBodHRwczovL2dpdGh1Yi5jb20vcHl0aG9uLXZlcnNpb25l
ZXIvcHl0aG9uLXZlcnNpb25lZXIKKiBCcmlhbiBXYXJuZXIKKiBMaWNlbnNl
OiBQdWJsaWMgRG9tYWluCiogQ29tcGF0aWJsZSB3aXRoOiBQeXRob24gMy42
LCAzLjcsIDMuOCwgMy45IGFuZCBweXB5MwoqIFshW0xhdGVzdCBWZXJzaW9u
XVtweXBpLWltYWdlXV1bcHlwaS11cmxdCiogWyFbQnVpbGQgU3RhdHVzXVt0
cmF2aXMtaW1hZ2VdXVt0cmF2aXMtdXJsXQoKVGhpcyBpcyBhIHRvb2wgZm9y
IG1hbmFnaW5nIGEgcmVjb3JkZWQgdmVyc2lvbiBudW1iZXIgaW4gZGlzdHV0
aWxzLWJhc2VkCnB5dGhvbiBwcm9qZWN0cy4gVGhlIGdvYWwgaXMgdG8gcmVt
b3ZlIHRoZSB0ZWRpb3VzIGFuZCBlcnJvci1wcm9uZSAidXBkYXRlCnRoZSBl
bWJlZGRlZCB2ZXJzaW9uIHN0cmluZyIgc3RlcCBmcm9tIHlvdXIgcmVsZWFz
ZSBwcm9jZXNzLiBNYWtpbmcgYSBuZXcKcmVsZWFzZSBzaG91bGQgYmUgYXMg
ZWFzeSBhcyByZWNvcmRpbmcgYSBuZXcgdGFnIGluIHlvdXIgdmVyc2lvbi1j
b250cm9sCnN5c3RlbSwgYW5kIG1heWJlIG1ha2luZyBuZXcgdGFyYmFsbHMu
CgoKIyMgUXVpY2sgSW5zdGFsbAoKKiBgcGlwIGluc3RhbGwgdmVyc2lvbmVl
cmAgdG8gc29tZXdoZXJlIGluIHlvdXIgJFBBVEgKKiBhZGQgYSBgW3ZlcnNp
b25lZXJdYCBzZWN0aW9uIHRvIHlvdXIgc2V0dXAuY2ZnIChzZWUgW0luc3Rh
bGxdKElOU1RBTEwubWQpKQoqIHJ1biBgdmVyc2lvbmVlciBpbnN0YWxsYCBp
biB5b3VyIHNvdXJjZSB0cmVlLCBjb21taXQgdGhlIHJlc3VsdHMKKiBWZXJp
ZnkgdmVyc2lvbiBpbmZvcm1hdGlvbiB3aXRoIGBweXRob24gc2V0dXAucHkg
dmVyc2lvbmAKCiMjIFZlcnNpb24gSWRlbnRpZmllcnMKClNvdXJjZSB0cmVl
cyBjb21lIGZyb20gYSB2YXJpZXR5IG9mIHBsYWNlczoKCiogYSB2ZXJzaW9u
LWNvbnRyb2wgc3lzdGVtIGNoZWNrb3V0IChtb3N0bHkgdXNlZCBieSBkZXZl
bG9wZXJzKQoqIGEgbmlnaHRseSB0YXJiYWxsLCBwcm9kdWNlZCBieSBidWls
ZCBhdXRvbWF0aW9uCiogYSBzbmFwc2hvdCB0YXJiYWxsLCBwcm9kdWNlZCBi
eSBhIHdlYi1iYXNlZCBWQ1MgYnJvd3NlciwgbGlrZSBnaXRodWIncwogICJ0
YXJiYWxsIGZyb20gdGFnIiBmZWF0dXJlCiogYSByZWxlYXNlIHRhcmJhbGws
IHByb2R1Y2VkIGJ5ICJzZXR1cC5weSBzZGlzdCIsIGRpc3RyaWJ1dGVkIHRo
cm91Z2ggUHlQSQoKV2l0aGluIGVhY2ggc291cmNlIHRyZWUsIHRoZSB2ZXJz
aW9uIGlkZW50aWZpZXIgKGVpdGhlciBhIHN0cmluZyBvciBhIG51bWJlciwK
dGhpcyB0b29sIGlzIGZvcm1hdC1hZ25vc3RpYykgY2FuIGNvbWUgZnJvbSBh
IHZhcmlldHkgb2YgcGxhY2VzOgoKKiBhc2sgdGhlIFZDUyB0b29sIGl0c2Vs
ZiwgZS5nLiAiZ2l0IGRlc2NyaWJlIiAoZm9yIGNoZWNrb3V0cyksIHdoaWNo
IGtub3dzCiAgYWJvdXQgcmVjZW50ICJ0YWdzIiBhbmQgYW4gYWJzb2x1dGUg
cmV2aXNpb24taWQKKiB0aGUgbmFtZSBvZiB0aGUgZGlyZWN0b3J5IGludG8g
d2hpY2ggdGhlIHRhcmJhbGwgd2FzIHVucGFja2VkCiogYW4gZXhwYW5kZWQg
VkNTIGtleXdvcmQgKCRJZCQsIGV0YykKKiBhIGBfdmVyc2lvbi5weWAgY3Jl
YXRlZCBieSBzb21lIGVhcmxpZXIgYnVpbGQgc3RlcAoKRm9yIHJlbGVhc2Vk
IHNvZnR3YXJlLCB0aGUgdmVyc2lvbiBpZGVudGlmaWVyIGlzIGNsb3NlbHkg
cmVsYXRlZCB0byBhIFZDUwp0YWcuIFNvbWUgcHJvamVjdHMgdXNlIHRhZyBu
YW1lcyB0aGF0IGluY2x1ZGUgbW9yZSB0aGFuIGp1c3QgdGhlIHZlcnNpb24K
c3RyaW5nIChlLmcuICJteXByb2plY3QtMS4yIiBpbnN0ZWFkIG9mIGp1c3Qg
IjEuMiIpLCBpbiB3aGljaCBjYXNlIHRoZSB0b29sCm5lZWRzIHRvIHN0cmlw
IHRoZSB0YWcgcHJlZml4IHRvIGV4dHJhY3QgdGhlIHZlcnNpb24gaWRlbnRp
Zmllci4gRm9yCnVucmVsZWFzZWQgc29mdHdhcmUgKGJldHdlZW4gdGFncyks
IHRoZSB2ZXJzaW9uIGlkZW50aWZpZXIgc2hvdWxkIHByb3ZpZGUKZW5vdWdo
IGluZm9ybWF0aW9uIHRvIGhlbHAgZGV2ZWxvcGVycyByZWNyZWF0ZSB0aGUg
c2FtZSB0cmVlLCB3aGlsZSBhbHNvCmdpdmluZyB0aGVtIGFuIGlkZWEgb2Yg
cm91Z2hseSBob3cgb2xkIHRoZSB0cmVlIGlzIChhZnRlciB2ZXJzaW9uIDEu
MiwgYmVmb3JlCnZlcnNpb24gMS4zKS4gTWFueSBWQ1Mgc3lzdGVtcyBjYW4g
cmVwb3J0IGEgZGVzY3JpcHRpb24gdGhhdCBjYXB0dXJlcyB0aGlzLApmb3Ig
ZXhhbXBsZSBgZ2l0IGRlc2NyaWJlIC0tdGFncyAtLWRpcnR5IC0tYWx3YXlz
YCByZXBvcnRzIHRoaW5ncyBsaWtlCiIwLjctMS1nNTc0YWI5OC1kaXJ0eSIg
dG8gaW5kaWNhdGUgdGhhdCB0aGUgY2hlY2tvdXQgaXMgb25lIHJldmlzaW9u
IHBhc3QgdGhlCjAuNyB0YWcsIGhhcyBhIHVuaXF1ZSByZXZpc2lvbiBpZCBv
ZiAiNTc0YWI5OCIsIGFuZCBpcyAiZGlydHkiIChpdCBoYXMKdW5jb21taXR0
ZWQgY2hhbmdlcykuCgpUaGUgdmVyc2lvbiBpZGVudGlmaWVyIGlzIHVzZWQg
Zm9yIG11bHRpcGxlIHB1cnBvc2VzOgoKKiB0byBhbGxvdyB0aGUgbW9kdWxl
IHRvIHNlbGYtaWRlbnRpZnkgaXRzIHZlcnNpb246IGBteXByb2plY3QuX192
ZXJzaW9uX19gCiogdG8gY2hvb3NlIGEgbmFtZSBhbmQgcHJlZml4IGZvciBh
ICdzZXR1cC5weSBzZGlzdCcgdGFyYmFsbAoKIyMgVGhlb3J5IG9mIE9wZXJh
dGlvbgoKVmVyc2lvbmVlciB3b3JrcyBieSBhZGRpbmcgYSBzcGVjaWFsIGBf
dmVyc2lvbi5weWAgZmlsZSBpbnRvIHlvdXIgc291cmNlCnRyZWUsIHdoZXJl
IHlvdXIgYF9faW5pdF9fLnB5YCBjYW4gaW1wb3J0IGl0LiBUaGlzIGBfdmVy
c2lvbi5weWAga25vd3MgaG93IHRvCmR5bmFtaWNhbGx5IGFzayB0aGUgVkNT
IHRvb2wgZm9yIHZlcnNpb24gaW5mb3JtYXRpb24gYXQgaW1wb3J0IHRpbWUu
CgpgX3ZlcnNpb24ucHlgIGFsc28gY29udGFpbnMgYCRSZXZpc2lvbiRgIG1h
cmtlcnMsIGFuZCB0aGUgaW5zdGFsbGF0aW9uCnByb2Nlc3MgbWFya3MgYF92
ZXJzaW9uLnB5YCB0byBoYXZlIHRoaXMgbWFya2VyIHJld3JpdHRlbiB3aXRo
IGEgdGFnIG5hbWUKZHVyaW5nIHRoZSBgZ2l0IGFyY2hpdmVgIGNvbW1hbmQu
IEFzIGEgcmVzdWx0LCBnZW5lcmF0ZWQgdGFyYmFsbHMgd2lsbApjb250YWlu
IGVub3VnaCBpbmZvcm1hdGlvbiB0byBnZXQgdGhlIHByb3BlciB2ZXJzaW9u
LgoKVG8gYWxsb3cgYHNldHVwLnB5YCB0byBjb21wdXRlIGEgdmVyc2lvbiB0
b28sIGEgYHZlcnNpb25lZXIucHlgIGlzIGFkZGVkIHRvCnRoZSB0b3AgbGV2
ZWwgb2YgeW91ciBzb3VyY2UgdHJlZSwgbmV4dCB0byBgc2V0dXAucHlgIGFu
ZCB0aGUgYHNldHVwLmNmZ2AKdGhhdCBjb25maWd1cmVzIGl0LiBUaGlzIG92
ZXJyaWRlcyBzZXZlcmFsIGRpc3R1dGlscy9zZXR1cHRvb2xzIGNvbW1hbmRz
IHRvCmNvbXB1dGUgdGhlIHZlcnNpb24gd2hlbiBpbnZva2VkLCBhbmQgY2hh
bmdlcyBgc2V0dXAucHkgYnVpbGRgIGFuZCBgc2V0dXAucHkKc2Rpc3RgIHRv
IHJlcGxhY2UgYF92ZXJzaW9uLnB5YCB3aXRoIGEgc21hbGwgc3RhdGljIGZp
bGUgdGhhdCBjb250YWlucyBqdXN0CnRoZSBnZW5lcmF0ZWQgdmVyc2lvbiBk
YXRhLgoKIyMgSW5zdGFsbGF0aW9uCgpTZWUgW0lOU1RBTEwubWRdKC4vSU5T
VEFMTC5tZCkgZm9yIGRldGFpbGVkIGluc3RhbGxhdGlvbiBpbnN0cnVjdGlv
bnMuCgojIyBWZXJzaW9uLVN0cmluZyBGbGF2b3JzCgpDb2RlIHdoaWNoIHVz
ZXMgVmVyc2lvbmVlciBjYW4gbGVhcm4gYWJvdXQgaXRzIHZlcnNpb24gc3Ry
aW5nIGF0IHJ1bnRpbWUgYnkKaW1wb3J0aW5nIGBfdmVyc2lvbmAgZnJvbSB5
b3VyIG1haW4gYF9faW5pdF9fLnB5YCBmaWxlIGFuZCBydW5uaW5nIHRoZQpg
Z2V0X3ZlcnNpb25zKClgIGZ1bmN0aW9uLiBGcm9tIHRoZSAib3V0c2lkZSIg
KGUuZy4gaW4gYHNldHVwLnB5YCksIHlvdSBjYW4KaW1wb3J0IHRoZSB0b3At
bGV2ZWwgYHZlcnNpb25lZXIucHlgIGFuZCBydW4gYGdldF92ZXJzaW9ucygp
YC4KCkJvdGggZnVuY3Rpb25zIHJldHVybiBhIGRpY3Rpb25hcnkgd2l0aCBk
aWZmZXJlbnQgZmxhdm9ycyBvZiB2ZXJzaW9uCmluZm9ybWF0aW9uOgoKKiBg
Wyd2ZXJzaW9uJ11gOiBBIGNvbmRlbnNlZCB2ZXJzaW9uIHN0cmluZywgcmVu
ZGVyZWQgdXNpbmcgdGhlIHNlbGVjdGVkCiAgc3R5bGUuIFRoaXMgaXMgdGhl
IG1vc3QgY29tbW9ubHkgdXNlZCB2YWx1ZSBmb3IgdGhlIHByb2plY3QncyB2
ZXJzaW9uCiAgc3RyaW5nLiBUaGUgZGVmYXVsdCAicGVwNDQwIiBzdHlsZSB5
aWVsZHMgc3RyaW5ncyBsaWtlIGAwLjExYCwKICBgMC4xMSsyLmcxMDc2Yzk3
YCwgb3IgYDAuMTErMi5nMTA3NmM5Ny5kaXJ0eWAuIFNlZSB0aGUgIlN0eWxl
cyIgc2VjdGlvbgogIGJlbG93IGZvciBhbHRlcm5hdGl2ZSBzdHlsZXMuCgoq
IGBbJ2Z1bGwtcmV2aXNpb25pZCddYDogZGV0YWlsZWQgcmV2aXNpb24gaWRl
bnRpZmllci4gRm9yIEdpdCwgdGhpcyBpcyB0aGUKICBmdWxsIFNIQTEgY29t
bWl0IGlkLCBlLmcuICIxMDc2Yzk3OGE4ZDNjZmM3MGY0MDhmZTU5NzRhYTZj
MDkyYzk0OWFjIi4KCiogYFsnZGF0ZSddYDogRGF0ZSBhbmQgdGltZSBvZiB0
aGUgbGF0ZXN0IGBIRUFEYCBjb21taXQuIEZvciBHaXQsIGl0IGlzIHRoZQog
IGNvbW1pdCBkYXRlIGluIElTTyA4NjAxIGZvcm1hdC4gVGhpcyB3aWxsIGJl
IE5vbmUgaWYgdGhlIGRhdGUgaXMgbm90CiAgYXZhaWxhYmxlLgoKKiBgWydk
aXJ0eSddYDogYSBib29sZWFuLCBUcnVlIGlmIHRoZSB0cmVlIGhhcyB1bmNv
bW1pdHRlZCBjaGFuZ2VzLiBOb3RlIHRoYXQKICB0aGlzIGlzIG9ubHkgYWNj
dXJhdGUgaWYgcnVuIGluIGEgVkNTIGNoZWNrb3V0LCBvdGhlcndpc2UgaXQg
aXMgbGlrZWx5IHRvCiAgYmUgRmFsc2Ugb3IgTm9uZQoKKiBgWydlcnJvcidd
YDogaWYgdGhlIHZlcnNpb24gc3RyaW5nIGNvdWxkIG5vdCBiZSBjb21wdXRl
ZCwgdGhpcyB3aWxsIGJlIHNldAogIHRvIGEgc3RyaW5nIGRlc2NyaWJpbmcg
dGhlIHByb2JsZW0sIG90aGVyd2lzZSBpdCB3aWxsIGJlIE5vbmUuIEl0IG1h
eSBiZQogIHVzZWZ1bCB0byB0aHJvdyBhbiBleGNlcHRpb24gaW4gc2V0dXAu
cHkgaWYgdGhpcyBpcyBzZXQsIHRvIGF2b2lkIGUuZy4KICBjcmVhdGluZyB0
YXJiYWxscyB3aXRoIGEgdmVyc2lvbiBzdHJpbmcgb2YgInVua25vd24iLgoK
U29tZSB2YXJpYW50cyBhcmUgbW9yZSB1c2VmdWwgdGhhbiBvdGhlcnMuIElu
Y2x1ZGluZyBgZnVsbC1yZXZpc2lvbmlkYCBpbiBhCmJ1ZyByZXBvcnQgc2hv
dWxkIGFsbG93IGRldmVsb3BlcnMgdG8gcmVjb25zdHJ1Y3QgdGhlIGV4YWN0
IGNvZGUgYmVpbmcgdGVzdGVkCihvciBpbmRpY2F0ZSB0aGUgcHJlc2VuY2Ug
b2YgbG9jYWwgY2hhbmdlcyB0aGF0IHNob3VsZCBiZSBzaGFyZWQgd2l0aCB0
aGUKZGV2ZWxvcGVycykuIGB2ZXJzaW9uYCBpcyBzdWl0YWJsZSBmb3IgZGlz
cGxheSBpbiBhbiAiYWJvdXQiIGJveCBvciBhIENMSQpgLS12ZXJzaW9uYCBv
dXRwdXQ6IGl0IGNhbiBiZSBlYXNpbHkgY29tcGFyZWQgYWdhaW5zdCByZWxl
YXNlIG5vdGVzIGFuZCBsaXN0cwpvZiBidWdzIGZpeGVkIGluIHZhcmlvdXMg
cmVsZWFzZXMuCgpUaGUgaW5zdGFsbGVyIGFkZHMgdGhlIGZvbGxvd2luZyB0
ZXh0IHRvIHlvdXIgYF9faW5pdF9fLnB5YCB0byBwbGFjZSBhIGJhc2ljCnZl
cnNpb24gaW4gYFlPVVJQUk9KRUNULl9fdmVyc2lvbl9fYDoKCiAgICBmcm9t
IC5fdmVyc2lvbiBpbXBvcnQgZ2V0X3ZlcnNpb25zCiAgICBfX3ZlcnNpb25f
XyA9IGdldF92ZXJzaW9ucygpWyd2ZXJzaW9uJ10KICAgIGRlbCBnZXRfdmVy
c2lvbnMKCiMjIFN0eWxlcwoKVGhlIHNldHVwLmNmZyBgc3R5bGU9YCBjb25m
aWd1cmF0aW9uIGNvbnRyb2xzIGhvdyB0aGUgVkNTIGluZm9ybWF0aW9uIGlz
CnJlbmRlcmVkIGludG8gYSB2ZXJzaW9uIHN0cmluZy4KClRoZSBkZWZhdWx0
IHN0eWxlLCAicGVwNDQwIiwgcHJvZHVjZXMgYSBQRVA0NDAtY29tcGxpYW50
IHN0cmluZywgZXF1YWwgdG8gdGhlCnVuLXByZWZpeGVkIHRhZyBuYW1lIGZv
ciBhY3R1YWwgcmVsZWFzZXMsIGFuZCBjb250YWluaW5nIGFuIGFkZGl0aW9u
YWwgImxvY2FsCnZlcnNpb24iIHNlY3Rpb24gd2l0aCBtb3JlIGRldGFpbCBm
b3IgaW4tYmV0d2VlbiBidWlsZHMuIEZvciBHaXQsIHRoaXMgaXMKVEFHWytE
SVNUQU5DRS5nSEVYWy5kaXJ0eV1dICwgdXNpbmcgaW5mb3JtYXRpb24gZnJv
bSBgZ2l0IGRlc2NyaWJlIC0tdGFncwotLWRpcnR5IC0tYWx3YXlzYC4gRm9y
IGV4YW1wbGUgIjAuMTErMi5nMTA3NmM5Ny5kaXJ0eSIgaW5kaWNhdGVzIHRo
YXQgdGhlCnRyZWUgaXMgbGlrZSB0aGUgIjEwNzZjOTciIGNvbW1pdCBidXQg
aGFzIHVuY29tbWl0dGVkIGNoYW5nZXMgKCIuZGlydHkiKSwgYW5kCnRoYXQg
dGhpcyBjb21taXQgaXMgdHdvIHJldmlzaW9ucyAoIisyIikgYmV5b25kIHRo
ZSAiMC4xMSIgdGFnLiBGb3IgcmVsZWFzZWQKc29mdHdhcmUgKGV4YWN0bHkg
ZXF1YWwgdG8gYSBrbm93biB0YWcpLCB0aGUgaWRlbnRpZmllciB3aWxsIG9u
bHkgY29udGFpbiB0aGUKc3RyaXBwZWQgdGFnLCBlLmcuICIwLjExIi4KCk90
aGVyIHN0eWxlcyBhcmUgYXZhaWxhYmxlLiBTZWUgW2RldGFpbHMubWRdKGRl
dGFpbHMubWQpIGluIHRoZSBWZXJzaW9uZWVyCnNvdXJjZSB0cmVlIGZvciBk
ZXNjcmlwdGlvbnMuCgojIyBEZWJ1Z2dpbmcKClZlcnNpb25lZXIgdHJpZXMg
dG8gYXZvaWQgZmF0YWwgZXJyb3JzOiBpZiBzb21ldGhpbmcgZ29lcyB3cm9u
ZywgaXQgd2lsbCB0ZW5kCnRvIHJldHVybiBhIHZlcnNpb24gb2YgIjArdW5r
bm93biIuIFRvIGludmVzdGlnYXRlIHRoZSBwcm9ibGVtLCBydW4gYHNldHVw
LnB5CnZlcnNpb25gLCB3aGljaCB3aWxsIHJ1biB0aGUgdmVyc2lvbi1sb29r
dXAgY29kZSBpbiBhIHZlcmJvc2UgbW9kZSwgYW5kIHdpbGwKZGlzcGxheSB0
aGUgZnVsbCBjb250ZW50cyBvZiBgZ2V0X3ZlcnNpb25zKClgIChpbmNsdWRp
bmcgdGhlIGBlcnJvcmAgc3RyaW5nLAp3aGljaCBtYXkgaGVscCBpZGVudGlm
eSB3aGF0IHdlbnQgd3JvbmcpLgoKIyMgS25vd24gTGltaXRhdGlvbnMKClNv
bWUgc2l0dWF0aW9ucyBhcmUga25vd24gdG8gY2F1c2UgcHJvYmxlbXMgZm9y
IFZlcnNpb25lZXIuIFRoaXMgZGV0YWlscyB0aGUKbW9zdCBzaWduaWZpY2Fu
dCBvbmVzLiBNb3JlIGNhbiBiZSBmb3VuZCBvbiBHaXRodWIKW2lzc3VlcyBw
YWdlXShodHRwczovL2dpdGh1Yi5jb20vcHl0aG9uLXZlcnNpb25lZXIvcHl0
aG9uLXZlcnNpb25lZXIvaXNzdWVzKS4KCiMjIyBTdWJwcm9qZWN0cwoKVmVy
c2lvbmVlciBoYXMgbGltaXRlZCBzdXBwb3J0IGZvciBzb3VyY2UgdHJlZXMg
aW4gd2hpY2ggYHNldHVwLnB5YCBpcyBub3QgaW4KdGhlIHJvb3QgZGlyZWN0
b3J5IChlLmcuIGBzZXR1cC5weWAgYW5kIGAuZ2l0L2AgYXJlICpub3QqIHNp
YmxpbmdzKS4gVGhlIGFyZQp0d28gY29tbW9uIHJlYXNvbnMgd2h5IGBzZXR1
cC5weWAgbWlnaHQgbm90IGJlIGluIHRoZSByb290OgoKKiBTb3VyY2UgdHJl
ZXMgd2hpY2ggY29udGFpbiBtdWx0aXBsZSBzdWJwcm9qZWN0cywgc3VjaCBh
cwogIFtCdWlsZGJvdF0oaHR0cHM6Ly9naXRodWIuY29tL2J1aWxkYm90L2J1
aWxkYm90KSwgd2hpY2ggY29udGFpbnMgYm90aAogICJtYXN0ZXIiIGFuZCAi
c2xhdmUiIHN1YnByb2plY3RzLCBlYWNoIHdpdGggdGhlaXIgb3duIGBzZXR1
cC5weWAsCiAgYHNldHVwLmNmZ2AsIGFuZCBgdG94LmluaWAuIFByb2plY3Rz
IGxpa2UgdGhlc2UgcHJvZHVjZSBtdWx0aXBsZSBQeVBJCiAgZGlzdHJpYnV0
aW9ucyAoYW5kIHVwbG9hZCBtdWx0aXBsZSBpbmRlcGVuZGVudGx5LWluc3Rh
bGxhYmxlIHRhcmJhbGxzKS4KKiBTb3VyY2UgdHJlZXMgd2hvc2UgbWFpbiBw
dXJwb3NlIGlzIHRvIGNvbnRhaW4gYSBDIGxpYnJhcnksIGJ1dCB3aGljaCBh
bHNvCiAgcHJvdmlkZSBiaW5kaW5ncyB0byBQeXRob24gKGFuZCBwZXJoYXBz
IG90aGVyIGxhbmd1YWdlcykgaW4gc3ViZGlyZWN0b3JpZXMuCgpWZXJzaW9u
ZWVyIHdpbGwgbG9vayBmb3IgYC5naXRgIGluIHBhcmVudCBkaXJlY3Rvcmll
cywgYW5kIG1vc3Qgb3BlcmF0aW9ucwpzaG91bGQgZ2V0IHRoZSByaWdodCB2
ZXJzaW9uIHN0cmluZy4gSG93ZXZlciBgcGlwYCBhbmQgYHNldHVwdG9vbHNg
IGhhdmUgYnVncwphbmQgaW1wbGVtZW50YXRpb24gZGV0YWlscyB3aGljaCBm
cmVxdWVudGx5IGNhdXNlIGBwaXAgaW5zdGFsbCAuYCBmcm9tIGEKc3VicHJv
amVjdCBkaXJlY3RvcnkgdG8gZmFpbCB0byBmaW5kIGEgY29ycmVjdCB2ZXJz
aW9uIHN0cmluZyAoc28gaXQgdXN1YWxseQpkZWZhdWx0cyB0byBgMCt1bmtu
b3duYCkuCgpgcGlwIGluc3RhbGwgLS1lZGl0YWJsZSAuYCBzaG91bGQgd29y
ayBjb3JyZWN0bHkuIGBzZXR1cC5weSBpbnN0YWxsYCBtaWdodAp3b3JrIHRv
by4KClBpcC04LjEuMSBpcyBrbm93biB0byBoYXZlIHRoaXMgcHJvYmxlbSwg
YnV0IGhvcGVmdWxseSBpdCB3aWxsIGdldCBmaXhlZCBpbgpzb21lIGxhdGVy
IHZlcnNpb24uCgpbQnVnICMzOF0oaHR0cHM6Ly9naXRodWIuY29tL3B5dGhv
bi12ZXJzaW9uZWVyL3B5dGhvbi12ZXJzaW9uZWVyL2lzc3Vlcy8zOCkgaXMg
dHJhY2tpbmcKdGhpcyBpc3N1ZS4gVGhlIGRpc2N1c3Npb24gaW4KW1BSICM2
MV0oaHR0cHM6Ly9naXRodWIuY29tL3B5dGhvbi12ZXJzaW9uZWVyL3B5dGhv
bi12ZXJzaW9uZWVyL3B1bGwvNjEpIGRlc2NyaWJlcyB0aGUKaXNzdWUgZnJv
bSB0aGUgVmVyc2lvbmVlciBzaWRlIGluIG1vcmUgZGV0YWlsLgpbcGlwIFBS
IzMxNzZdKGh0dHBzOi8vZ2l0aHViLmNvbS9weXBhL3BpcC9wdWxsLzMxNzYp
IGFuZApbcGlwIFBSIzM2MTVdKGh0dHBzOi8vZ2l0aHViLmNvbS9weXBhL3Bp
cC9wdWxsLzM2MTUpIGNvbnRhaW4gd29yayB0byBpbXByb3ZlCnBpcCB0byBs
ZXQgVmVyc2lvbmVlciB3b3JrIGNvcnJlY3RseS4KClZlcnNpb25lZXItMC4x
NiBhbmQgZWFybGllciBvbmx5IGxvb2tlZCBmb3IgYSBgLmdpdGAgZGlyZWN0
b3J5IG5leHQgdG8gdGhlCmBzZXR1cC5jZmdgLCBzbyBzdWJwcm9qZWN0cyB3
ZXJlIGNvbXBsZXRlbHkgdW5zdXBwb3J0ZWQgd2l0aCB0aG9zZSByZWxlYXNl
cy4KCiMjIyBFZGl0YWJsZSBpbnN0YWxscyB3aXRoIHNldHVwdG9vbHMgPD0g
MTguNQoKYHNldHVwLnB5IGRldmVsb3BgIGFuZCBgcGlwIGluc3RhbGwgLS1l
ZGl0YWJsZSAuYCBhbGxvdyB5b3UgdG8gaW5zdGFsbCBhCnByb2plY3QgaW50
byBhIHZpcnR1YWxlbnYgb25jZSwgdGhlbiBjb250aW51ZSBlZGl0aW5nIHRo
ZSBzb3VyY2UgY29kZSAoYW5kCnRlc3QpIHdpdGhvdXQgcmUtaW5zdGFsbGlu
ZyBhZnRlciBldmVyeSBjaGFuZ2UuCgoiRW50cnktcG9pbnQgc2NyaXB0cyIg
KGBzZXR1cChlbnRyeV9wb2ludHM9eyJjb25zb2xlX3NjcmlwdHMiOiAuLn0p
YCkgYXJlIGEKY29udmVuaWVudCB3YXkgdG8gc3BlY2lmeSBleGVjdXRhYmxl
IHNjcmlwdHMgdGhhdCBzaG91bGQgYmUgaW5zdGFsbGVkIGFsb25nCndpdGgg
dGhlIHB5dGhvbiBwYWNrYWdlLgoKVGhlc2UgYm90aCB3b3JrIGFzIGV4cGVj
dGVkIHdoZW4gdXNpbmcgbW9kZXJuIHNldHVwdG9vbHMuIFdoZW4gdXNpbmcK
c2V0dXB0b29scy0xOC41IG9yIGVhcmxpZXIsIGhvd2V2ZXIsIGNlcnRhaW4g
b3BlcmF0aW9ucyB3aWxsIGNhdXNlCmBwa2dfcmVzb3VyY2VzLkRpc3RyaWJ1
dGlvbk5vdEZvdW5kYCBlcnJvcnMgd2hlbiBydW5uaW5nIHRoZSBlbnRyeXBv
aW50CnNjcmlwdCwgd2hpY2ggbXVzdCBiZSByZXNvbHZlZCBieSByZS1pbnN0
YWxsaW5nIHRoZSBwYWNrYWdlLiBUaGlzIGhhcHBlbnMKd2hlbiB0aGUgaW5z
dGFsbCBoYXBwZW5zIHdpdGggb25lIHZlcnNpb24sIHRoZW4gdGhlIGVnZ19p
bmZvIGRhdGEgaXMKcmVnZW5lcmF0ZWQgd2hpbGUgYSBkaWZmZXJlbnQgdmVy
c2lvbiBpcyBjaGVja2VkIG91dC4gTWFueSBzZXR1cC5weSBjb21tYW5kcwpj
YXVzZSBlZ2dfaW5mbyB0byBiZSByZWJ1aWx0IChpbmNsdWRpbmcgYHNkaXN0
YCwgYHdoZWVsYCwgYW5kIGluc3RhbGxpbmcgaW50bwphIGRpZmZlcmVudCB2
aXJ0dWFsZW52KSwgc28gdGhpcyBjYW4gYmUgc3VycHJpc2luZy4KCltCdWcg
IzgzXShodHRwczovL2dpdGh1Yi5jb20vcHl0aG9uLXZlcnNpb25lZXIvcHl0
aG9uLXZlcnNpb25lZXIvaXNzdWVzLzgzKSBkZXNjcmliZXMKdGhpcyBvbmUs
IGJ1dCB1cGdyYWRpbmcgdG8gYSBuZXdlciB2ZXJzaW9uIG9mIHNldHVwdG9v
bHMgc2hvdWxkIHByb2JhYmx5CnJlc29sdmUgaXQuCgoKIyMgVXBkYXRpbmcg
VmVyc2lvbmVlcgoKVG8gdXBncmFkZSB5b3VyIHByb2plY3QgdG8gYSBuZXcg
cmVsZWFzZSBvZiBWZXJzaW9uZWVyLCBkbyB0aGUgZm9sbG93aW5nOgoKKiBp
bnN0YWxsIHRoZSBuZXcgVmVyc2lvbmVlciAoYHBpcCBpbnN0YWxsIC1VIHZl
cnNpb25lZXJgIG9yIGVxdWl2YWxlbnQpCiogZWRpdCBgc2V0dXAuY2ZnYCwg
aWYgbmVjZXNzYXJ5LCB0byBpbmNsdWRlIGFueSBuZXcgY29uZmlndXJhdGlv
biBzZXR0aW5ncwogIGluZGljYXRlZCBieSB0aGUgcmVsZWFzZSBub3Rlcy4g
U2VlIFtVUEdSQURJTkddKC4vVVBHUkFESU5HLm1kKSBmb3IgZGV0YWlscy4K
KiByZS1ydW4gYHZlcnNpb25lZXIgaW5zdGFsbGAgaW4geW91ciBzb3VyY2Ug
dHJlZSwgdG8gcmVwbGFjZQogIGBTUkMvX3ZlcnNpb24ucHlgCiogY29tbWl0
IGFueSBjaGFuZ2VkIGZpbGVzCgojIyBGdXR1cmUgRGlyZWN0aW9ucwoKVGhp
cyB0b29sIGlzIGRlc2lnbmVkIHRvIG1ha2UgaXQgZWFzaWx5IGV4dGVuZGVk
IHRvIG90aGVyIHZlcnNpb24tY29udHJvbApzeXN0ZW1zOiBhbGwgVkNTLXNw
ZWNpZmljIGNvbXBvbmVudHMgYXJlIGluIHNlcGFyYXRlIGRpcmVjdG9yaWVz
IGxpa2UKc3JjL2dpdC8gLiBUaGUgdG9wLWxldmVsIGB2ZXJzaW9uZWVyLnB5
YCBzY3JpcHQgaXMgYXNzZW1ibGVkIGZyb20gdGhlc2UKY29tcG9uZW50cyBi
eSBydW5uaW5nIG1ha2UtdmVyc2lvbmVlci5weSAuIEluIHRoZSBmdXR1cmUs
IG1ha2UtdmVyc2lvbmVlci5weQp3aWxsIHRha2UgYSBWQ1MgbmFtZSBhcyBh
biBhcmd1bWVudCwgYW5kIHdpbGwgY29uc3RydWN0IGEgdmVyc2lvbiBvZgpg
dmVyc2lvbmVlci5weWAgdGhhdCBpcyBzcGVjaWZpYyB0byB0aGUgZ2l2ZW4g
VkNTLiBJdCBtaWdodCBhbHNvIHRha2UgdGhlCmNvbmZpZ3VyYXRpb24gYXJn
dW1lbnRzIHRoYXQgYXJlIGN1cnJlbnRseSBwcm92aWRlZCBtYW51YWxseSBk
dXJpbmcKaW5zdGFsbGF0aW9uIGJ5IGVkaXRpbmcgc2V0dXAucHkgLiBBbHRl
cm5hdGl2ZWx5LCBpdCBtaWdodCBnbyB0aGUgb3RoZXIKZGlyZWN0aW9uIGFu
ZCBpbmNsdWRlIGNvZGUgZnJvbSBhbGwgc3VwcG9ydGVkIFZDUyBzeXN0ZW1z
LCByZWR1Y2luZyB0aGUKbnVtYmVyIG9mIGludGVybWVkaWF0ZSBzY3JpcHRz
LgoKIyMgU2ltaWxhciBwcm9qZWN0cwoKKiBbc2V0dXB0b29sc19zY21dKGh0
dHBzOi8vZ2l0aHViLmNvbS9weXBhL3NldHVwdG9vbHNfc2NtLykgLSBhIG5v
bi12ZW5kb3JlZCBidWlsZC10aW1lCiAgZGVwZW5kZW5jeQoqIFttaW52ZXJd
KGh0dHBzOi8vZ2l0aHViLmNvbS9qYndlc3Rvbi9taW5pdmVyKSAtIGEgbGln
aHR3ZWlnaHQgcmVpbXBsZW1lbnRhdGlvbiBvZgogIHZlcnNpb25lZXIKCiMj
IExpY2Vuc2UKClRvIG1ha2UgVmVyc2lvbmVlciBlYXNpZXIgdG8gZW1iZWQs
IGFsbCBpdHMgY29kZSBpcyBkZWRpY2F0ZWQgdG8gdGhlIHB1YmxpYwpkb21h
aW4uIFRoZSBgX3ZlcnNpb24ucHlgIHRoYXQgaXQgY3JlYXRlcyBpcyBhbHNv
IGluIHRoZSBwdWJsaWMgZG9tYWluLgpTcGVjaWZpY2FsbHksIGJvdGggYXJl
IHJlbGVhc2VkIHVuZGVyIHRoZSBDcmVhdGl2ZSBDb21tb25zICJQdWJsaWMg
RG9tYWluCkRlZGljYXRpb24iIGxpY2Vuc2UgKENDMC0xLjApLCBhcyBkZXNj
cmliZWQgaW4KaHR0cHM6Ly9jcmVhdGl2ZWNvbW1vbnMub3JnL3B1YmxpY2Rv
bWFpbi96ZXJvLzEuMC8gLgoKW3B5cGktaW1hZ2VdOiBodHRwczovL2ltZy5z
aGllbGRzLmlvL3B5cGkvdi92ZXJzaW9uZWVyLnN2ZwpbcHlwaS11cmxdOiBo
dHRwczovL3B5cGkucHl0aG9uLm9yZy9weXBpL3ZlcnNpb25lZXIvClt0cmF2
aXMtaW1hZ2VdOgpodHRwczovL2ltZy5zaGllbGRzLmlvL3RyYXZpcy9jb20v
cHl0aG9uLXZlcnNpb25lZXIvcHl0aG9uLXZlcnNpb25lZXIuc3ZnClt0cmF2
aXMtdXJsXTogaHR0cHM6Ly90cmF2aXMtY2kuY29tL2dpdGh1Yi9weXRob24t
dmVyc2lvbmVlci9weXRob24tdmVyc2lvbmVlcgoKIiIiCgppbXBvcnQgY29u
ZmlncGFyc2VyCmltcG9ydCBlcnJubwppbXBvcnQganNvbgppbXBvcnQgb3MK
aW1wb3J0IHJlCmltcG9ydCBzdWJwcm9jZXNzCmltcG9ydCBzeXMKCgpjbGFz
cyBWZXJzaW9uZWVyQ29uZmlnOgogICAgIiIiQ29udGFpbmVyIGZvciBWZXJz
aW9uZWVyIGNvbmZpZ3VyYXRpb24gcGFyYW1ldGVycy4iIiIKCgpkZWYgZ2V0
X3Jvb3QoKToKICAgICIiIkdldCB0aGUgcHJvamVjdCByb290IGRpcmVjdG9y
eS4KCiAgICBXZSByZXF1aXJlIHRoYXQgYWxsIGNvbW1hbmRzIGFyZSBydW4g
ZnJvbSB0aGUgcHJvamVjdCByb290LCBpLmUuIHRoZQogICAgZGlyZWN0b3J5
IHRoYXQgY29udGFpbnMgc2V0dXAucHksIHNldHVwLmNmZywgYW5kIHZlcnNp
b25lZXIucHkgLgogICAgIiIiCiAgICByb290ID0gb3MucGF0aC5yZWFscGF0
aChvcy5wYXRoLmFic3BhdGgob3MuZ2V0Y3dkKCkpKQogICAgc2V0dXBfcHkg
PSBvcy5wYXRoLmpvaW4ocm9vdCwgInNldHVwLnB5IikKICAgIHZlcnNpb25l
ZXJfcHkgPSBvcy5wYXRoLmpvaW4ocm9vdCwgInZlcnNpb25lZXIucHkiKQog
ICAgaWYgbm90IChvcy5wYXRoLmV4aXN0cyhzZXR1cF9weSkgb3Igb3MucGF0
aC5leGlzdHModmVyc2lvbmVlcl9weSkpOgogICAgICAgICMgYWxsb3cgJ3B5
dGhvbiBwYXRoL3RvL3NldHVwLnB5IENPTU1BTkQnCiAgICAgICAgcm9vdCA9
IG9zLnBhdGguZGlybmFtZShvcy5wYXRoLnJlYWxwYXRoKG9zLnBhdGguYWJz
cGF0aChzeXMuYXJndlswXSkpKQogICAgICAgIHNldHVwX3B5ID0gb3MucGF0
aC5qb2luKHJvb3QsICJzZXR1cC5weSIpCiAgICAgICAgdmVyc2lvbmVlcl9w
eSA9IG9zLnBhdGguam9pbihyb290LCAidmVyc2lvbmVlci5weSIpCiAgICBp
ZiBub3QgKG9zLnBhdGguZXhpc3RzKHNldHVwX3B5KSBvciBvcy5wYXRoLmV4
aXN0cyh2ZXJzaW9uZWVyX3B5KSk6CiAgICAgICAgZXJyID0gKCJWZXJzaW9u
ZWVyIHdhcyB1bmFibGUgdG8gcnVuIHRoZSBwcm9qZWN0IHJvb3QgZGlyZWN0
b3J5LiAiCiAgICAgICAgICAgICAgICJWZXJzaW9uZWVyIHJlcXVpcmVzIHNl
dHVwLnB5IHRvIGJlIGV4ZWN1dGVkIGZyb20gIgogICAgICAgICAgICAgICAi
aXRzIGltbWVkaWF0ZSBkaXJlY3RvcnkgKGxpa2UgJ3B5dGhvbiBzZXR1cC5w
eSBDT01NQU5EJyksICIKICAgICAgICAgICAgICAgIm9yIGluIGEgd2F5IHRo
YXQgbGV0cyBpdCB1c2Ugc3lzLmFyZ3ZbMF0gdG8gZmluZCB0aGUgcm9vdCAi
CiAgICAgICAgICAgICAgICIobGlrZSAncHl0aG9uIHBhdGgvdG8vc2V0dXAu
cHkgQ09NTUFORCcpLiIpCiAgICAgICAgcmFpc2UgVmVyc2lvbmVlckJhZFJv
b3RFcnJvcihlcnIpCiAgICB0cnk6CiAgICAgICAgIyBDZXJ0YWluIHJ1bnRp
bWUgd29ya2Zsb3dzIChzZXR1cC5weSBpbnN0YWxsL2RldmVsb3AgaW4gYSBz
ZXR1cHRvb2xzCiAgICAgICAgIyB0cmVlKSBleGVjdXRlIGFsbCBkZXBlbmRl
bmNpZXMgaW4gYSBzaW5nbGUgcHl0aG9uIHByb2Nlc3MsIHNvCiAgICAgICAg
IyAidmVyc2lvbmVlciIgbWF5IGJlIGltcG9ydGVkIG11bHRpcGxlIHRpbWVz
LCBhbmQgcHl0aG9uJ3Mgc2hhcmVkCiAgICAgICAgIyBtb2R1bGUtaW1wb3J0
IHRhYmxlIHdpbGwgY2FjaGUgdGhlIGZpcnN0IG9uZS4gU28gd2UgY2FuJ3Qg
dXNlCiAgICAgICAgIyBvcy5wYXRoLmRpcm5hbWUoX19maWxlX18pLCBhcyB0
aGF0IHdpbGwgZmluZCB3aGljaGV2ZXIKICAgICAgICAjIHZlcnNpb25lZXIu
cHkgd2FzIGZpcnN0IGltcG9ydGVkLCBldmVuIGluIGxhdGVyIHByb2plY3Rz
LgogICAgICAgIG1lID0gb3MucGF0aC5yZWFscGF0aChvcy5wYXRoLmFic3Bh
dGgoX19maWxlX18pKQogICAgICAgIG1lX2RpciA9IG9zLnBhdGgubm9ybWNh
c2Uob3MucGF0aC5zcGxpdGV4dChtZSlbMF0pCiAgICAgICAgdnNyX2RpciA9
IG9zLnBhdGgubm9ybWNhc2Uob3MucGF0aC5zcGxpdGV4dCh2ZXJzaW9uZWVy
X3B5KVswXSkKICAgICAgICBpZiBtZV9kaXIgIT0gdnNyX2RpcjoKICAgICAg
ICAgICAgcHJpbnQoIldhcm5pbmc6IGJ1aWxkIGluICVzIGlzIHVzaW5nIHZl
cnNpb25lZXIucHkgZnJvbSAlcyIKICAgICAgICAgICAgICAgICAgJSAob3Mu
cGF0aC5kaXJuYW1lKG1lKSwgdmVyc2lvbmVlcl9weSkpCiAgICBleGNlcHQg
TmFtZUVycm9yOgogICAgICAgIHBhc3MKICAgIHJldHVybiByb290CgoKZGVm
IGdldF9jb25maWdfZnJvbV9yb290KHJvb3QpOgogICAgIiIiUmVhZCB0aGUg
cHJvamVjdCBzZXR1cC5jZmcgZmlsZSB0byBkZXRlcm1pbmUgVmVyc2lvbmVl
ciBjb25maWcuIiIiCiAgICAjIFRoaXMgbWlnaHQgcmFpc2UgRW52aXJvbm1l
bnRFcnJvciAoaWYgc2V0dXAuY2ZnIGlzIG1pc3NpbmcpLCBvcgogICAgIyBj
b25maWdwYXJzZXIuTm9TZWN0aW9uRXJyb3IgKGlmIGl0IGxhY2tzIGEgW3Zl
cnNpb25lZXJdIHNlY3Rpb24pLCBvcgogICAgIyBjb25maWdwYXJzZXIuTm9P
cHRpb25FcnJvciAoaWYgaXQgbGFja3MgIlZDUz0iKS4gU2VlIHRoZSBkb2Nz
dHJpbmcgYXQKICAgICMgdGhlIHRvcCBvZiB2ZXJzaW9uZWVyLnB5IGZvciBp
bnN0cnVjdGlvbnMgb24gd3JpdGluZyB5b3VyIHNldHVwLmNmZyAuCiAgICBz
ZXR1cF9jZmcgPSBvcy5wYXRoLmpvaW4ocm9vdCwgInNldHVwLmNmZyIpCiAg
ICBwYXJzZXIgPSBjb25maWdwYXJzZXIuQ29uZmlnUGFyc2VyKCkKICAgIHdp
dGggb3BlbihzZXR1cF9jZmcsICJyIikgYXMgZjoKICAgICAgICBwYXJzZXIu
cmVhZF9maWxlKGYpCiAgICBWQ1MgPSBwYXJzZXIuZ2V0KCJ2ZXJzaW9uZWVy
IiwgIlZDUyIpICAjIG1hbmRhdG9yeQoKICAgIGRlZiBnZXQocGFyc2VyLCBu
YW1lKToKICAgICAgICBpZiBwYXJzZXIuaGFzX29wdGlvbigidmVyc2lvbmVl
ciIsIG5hbWUpOgogICAgICAgICAgICByZXR1cm4gcGFyc2VyLmdldCgidmVy
c2lvbmVlciIsIG5hbWUpCiAgICAgICAgcmV0dXJuIE5vbmUKICAgIGNmZyA9
IFZlcnNpb25lZXJDb25maWcoKQogICAgY2ZnLlZDUyA9IFZDUwogICAgY2Zn
LnN0eWxlID0gZ2V0KHBhcnNlciwgInN0eWxlIikgb3IgIiIKICAgIGNmZy52
ZXJzaW9uZmlsZV9zb3VyY2UgPSBnZXQocGFyc2VyLCAidmVyc2lvbmZpbGVf
c291cmNlIikKICAgIGNmZy52ZXJzaW9uZmlsZV9idWlsZCA9IGdldChwYXJz
ZXIsICJ2ZXJzaW9uZmlsZV9idWlsZCIpCiAgICBjZmcudGFnX3ByZWZpeCA9
IGdldChwYXJzZXIsICJ0YWdfcHJlZml4IikKICAgIGlmIGNmZy50YWdfcHJl
Zml4IGluICgiJyciLCAnIiInKToKICAgICAgICBjZmcudGFnX3ByZWZpeCA9
ICIiCiAgICBjZmcucGFyZW50ZGlyX3ByZWZpeCA9IGdldChwYXJzZXIsICJw
YXJlbnRkaXJfcHJlZml4IikKICAgIGNmZy52ZXJib3NlID0gZ2V0KHBhcnNl
ciwgInZlcmJvc2UiKQogICAgcmV0dXJuIGNmZwoKCmNsYXNzIE5vdFRoaXNN
ZXRob2QoRXhjZXB0aW9uKToKICAgICIiIkV4Y2VwdGlvbiByYWlzZWQgaWYg
YSBtZXRob2QgaXMgbm90IHZhbGlkIGZvciB0aGUgY3VycmVudCBzY2VuYXJp
by4iIiIKCgojIHRoZXNlIGRpY3Rpb25hcmllcyBjb250YWluIFZDUy1zcGVj
aWZpYyB0b29scwpMT05HX1ZFUlNJT05fUFkgPSB7fQpIQU5ETEVSUyA9IHt9
CgoKZGVmIHJlZ2lzdGVyX3Zjc19oYW5kbGVyKHZjcywgbWV0aG9kKTogICMg
ZGVjb3JhdG9yCiAgICAiIiJDcmVhdGUgZGVjb3JhdG9yIHRvIG1hcmsgYSBt
ZXRob2QgYXMgdGhlIGhhbmRsZXIgb2YgYSBWQ1MuIiIiCiAgICBkZWYgZGVj
b3JhdGUoZik6CiAgICAgICAgIiIiU3RvcmUgZiBpbiBIQU5ETEVSU1t2Y3Nd
W21ldGhvZF0uIiIiCiAgICAgICAgaWYgdmNzIG5vdCBpbiBIQU5ETEVSUzoK
ICAgICAgICAgICAgSEFORExFUlNbdmNzXSA9IHt9CiAgICAgICAgSEFORExF
UlNbdmNzXVttZXRob2RdID0gZgogICAgICAgIHJldHVybiBmCiAgICByZXR1
cm4gZGVjb3JhdGUKCgpkZWYgcnVuX2NvbW1hbmQoY29tbWFuZHMsIGFyZ3Ms
IGN3ZD1Ob25lLCB2ZXJib3NlPUZhbHNlLCBoaWRlX3N0ZGVycj1GYWxzZSwK
ICAgICAgICAgICAgICAgIGVudj1Ob25lKToKICAgICIiIkNhbGwgdGhlIGdp
dmVuIGNvbW1hbmQocykuIiIiCiAgICBhc3NlcnQgaXNpbnN0YW5jZShjb21t
YW5kcywgbGlzdCkKICAgIHAgPSBOb25lCiAgICBmb3IgYyBpbiBjb21tYW5k
czoKICAgICAgICB0cnk6CiAgICAgICAgICAgIGRpc3BjbWQgPSBzdHIoW2Nd
ICsgYXJncykKICAgICAgICAgICAgIyByZW1lbWJlciBzaGVsbD1GYWxzZSwg
c28gdXNlIGdpdC5jbWQgb24gd2luZG93cywgbm90IGp1c3QgZ2l0CiAgICAg
ICAgICAgIHAgPSBzdWJwcm9jZXNzLlBvcGVuKFtjXSArIGFyZ3MsIGN3ZD1j
d2QsIGVudj1lbnYsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
IHN0ZG91dD1zdWJwcm9jZXNzLlBJUEUsCiAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIHN0ZGVycj0oc3VicHJvY2Vzcy5QSVBFIGlmIGhpZGVf
c3RkZXJyCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgZWxzZSBOb25lKSkKICAgICAgICAgICAgYnJlYWsKICAgICAgICBleGNl
cHQgRW52aXJvbm1lbnRFcnJvcjoKICAgICAgICAgICAgZSA9IHN5cy5leGNf
aW5mbygpWzFdCiAgICAgICAgICAgIGlmIGUuZXJybm8gPT0gZXJybm8uRU5P
RU5UOgogICAgICAgICAgICAgICAgY29udGludWUKICAgICAgICAgICAgaWYg
dmVyYm9zZToKICAgICAgICAgICAgICAgIHByaW50KCJ1bmFibGUgdG8gcnVu
ICVzIiAlIGRpc3BjbWQpCiAgICAgICAgICAgICAgICBwcmludChlKQogICAg
ICAgICAgICByZXR1cm4gTm9uZSwgTm9uZQogICAgZWxzZToKICAgICAgICBp
ZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgidW5hYmxlIHRvIGZpbmQg
Y29tbWFuZCwgdHJpZWQgJXMiICUgKGNvbW1hbmRzLCkpCiAgICAgICAgcmV0
dXJuIE5vbmUsIE5vbmUKICAgIHN0ZG91dCA9IHAuY29tbXVuaWNhdGUoKVsw
XS5zdHJpcCgpLmRlY29kZSgpCiAgICBpZiBwLnJldHVybmNvZGUgIT0gMDoK
ICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgidW5hYmxl
IHRvIHJ1biAlcyAoZXJyb3IpIiAlIGRpc3BjbWQpCiAgICAgICAgICAgIHBy
aW50KCJzdGRvdXQgd2FzICVzIiAlIHN0ZG91dCkKICAgICAgICByZXR1cm4g
Tm9uZSwgcC5yZXR1cm5jb2RlCiAgICByZXR1cm4gc3Rkb3V0LCBwLnJldHVy
bmNvZGUKCgpMT05HX1ZFUlNJT05fUFlbJ2dpdCddID0gcicnJwojIFRoaXMg
ZmlsZSBoZWxwcyB0byBjb21wdXRlIGEgdmVyc2lvbiBudW1iZXIgaW4gc291
cmNlIHRyZWVzIG9idGFpbmVkIGZyb20KIyBnaXQtYXJjaGl2ZSB0YXJiYWxs
IChzdWNoIGFzIHRob3NlIHByb3ZpZGVkIGJ5IGdpdGh1YnMgZG93bmxvYWQt
ZnJvbS10YWcKIyBmZWF0dXJlKS4gRGlzdHJpYnV0aW9uIHRhcmJhbGxzIChi
dWlsdCBieSBzZXR1cC5weSBzZGlzdCkgYW5kIGJ1aWxkCiMgZGlyZWN0b3Jp
ZXMgKHByb2R1Y2VkIGJ5IHNldHVwLnB5IGJ1aWxkKSB3aWxsIGNvbnRhaW4g
YSBtdWNoIHNob3J0ZXIgZmlsZQojIHRoYXQganVzdCBjb250YWlucyB0aGUg
Y29tcHV0ZWQgdmVyc2lvbiBudW1iZXIuCgojIFRoaXMgZmlsZSBpcyByZWxl
YXNlZCBpbnRvIHRoZSBwdWJsaWMgZG9tYWluLiBHZW5lcmF0ZWQgYnkKIyB2
ZXJzaW9uZWVyLTAuMTkgKGh0dHBzOi8vZ2l0aHViLmNvbS9weXRob24tdmVy
c2lvbmVlci9weXRob24tdmVyc2lvbmVlcikKCiIiIkdpdCBpbXBsZW1lbnRh
dGlvbiBvZiBfdmVyc2lvbi5weS4iIiIKCmltcG9ydCBlcnJubwppbXBvcnQg
b3MKaW1wb3J0IHJlCmltcG9ydCBzdWJwcm9jZXNzCmltcG9ydCBzeXMKCgpk
ZWYgZ2V0X2tleXdvcmRzKCk6CiAgICAiIiJHZXQgdGhlIGtleXdvcmRzIG5l
ZWRlZCB0byBsb29rIHVwIHRoZSB2ZXJzaW9uIGluZm9ybWF0aW9uLiIiIgog
ICAgIyB0aGVzZSBzdHJpbmdzIHdpbGwgYmUgcmVwbGFjZWQgYnkgZ2l0IGR1
cmluZyBnaXQtYXJjaGl2ZS4KICAgICMgc2V0dXAucHkvdmVyc2lvbmVlci5w
eSB3aWxsIGdyZXAgZm9yIHRoZSB2YXJpYWJsZSBuYW1lcywgc28gdGhleSBt
dXN0CiAgICAjIGVhY2ggYmUgZGVmaW5lZCBvbiBhIGxpbmUgb2YgdGhlaXIg
b3duLiBfdmVyc2lvbi5weSB3aWxsIGp1c3QgY2FsbAogICAgIyBnZXRfa2V5
d29yZHMoKS4KICAgIGdpdF9yZWZuYW1lcyA9ICIlKERPTExBUilzRm9ybWF0
OiUlZCUoRE9MTEFSKXMiCiAgICBnaXRfZnVsbCA9ICIlKERPTExBUilzRm9y
bWF0OiUlSCUoRE9MTEFSKXMiCiAgICBnaXRfZGF0ZSA9ICIlKERPTExBUilz
Rm9ybWF0OiUlY2klKERPTExBUilzIgogICAga2V5d29yZHMgPSB7InJlZm5h
bWVzIjogZ2l0X3JlZm5hbWVzLCAiZnVsbCI6IGdpdF9mdWxsLCAiZGF0ZSI6
IGdpdF9kYXRlfQogICAgcmV0dXJuIGtleXdvcmRzCgoKY2xhc3MgVmVyc2lv
bmVlckNvbmZpZzoKICAgICIiIkNvbnRhaW5lciBmb3IgVmVyc2lvbmVlciBj
b25maWd1cmF0aW9uIHBhcmFtZXRlcnMuIiIiCgoKZGVmIGdldF9jb25maWco
KToKICAgICIiIkNyZWF0ZSwgcG9wdWxhdGUgYW5kIHJldHVybiB0aGUgVmVy
c2lvbmVlckNvbmZpZygpIG9iamVjdC4iIiIKICAgICMgdGhlc2Ugc3RyaW5n
cyBhcmUgZmlsbGVkIGluIHdoZW4gJ3NldHVwLnB5IHZlcnNpb25lZXInIGNy
ZWF0ZXMKICAgICMgX3ZlcnNpb24ucHkKICAgIGNmZyA9IFZlcnNpb25lZXJD
b25maWcoKQogICAgY2ZnLlZDUyA9ICJnaXQiCiAgICBjZmcuc3R5bGUgPSAi
JShTVFlMRSlzIgogICAgY2ZnLnRhZ19wcmVmaXggPSAiJShUQUdfUFJFRklY
KXMiCiAgICBjZmcucGFyZW50ZGlyX3ByZWZpeCA9ICIlKFBBUkVOVERJUl9Q
UkVGSVgpcyIKICAgIGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UgPSAiJShWRVJT
SU9ORklMRV9TT1VSQ0UpcyIKICAgIGNmZy52ZXJib3NlID0gRmFsc2UKICAg
IHJldHVybiBjZmcKCgpjbGFzcyBOb3RUaGlzTWV0aG9kKEV4Y2VwdGlvbik6
CiAgICAiIiJFeGNlcHRpb24gcmFpc2VkIGlmIGEgbWV0aG9kIGlzIG5vdCB2
YWxpZCBmb3IgdGhlIGN1cnJlbnQgc2NlbmFyaW8uIiIiCgoKTE9OR19WRVJT
SU9OX1BZID0ge30KSEFORExFUlMgPSB7fQoKCmRlZiByZWdpc3Rlcl92Y3Nf
aGFuZGxlcih2Y3MsIG1ldGhvZCk6ICAjIGRlY29yYXRvcgogICAgIiIiQ3Jl
YXRlIGRlY29yYXRvciB0byBtYXJrIGEgbWV0aG9kIGFzIHRoZSBoYW5kbGVy
IG9mIGEgVkNTLiIiIgogICAgZGVmIGRlY29yYXRlKGYpOgogICAgICAgICIi
IlN0b3JlIGYgaW4gSEFORExFUlNbdmNzXVttZXRob2RdLiIiIgogICAgICAg
IGlmIHZjcyBub3QgaW4gSEFORExFUlM6CiAgICAgICAgICAgIEhBTkRMRVJT
W3Zjc10gPSB7fQogICAgICAgIEhBTkRMRVJTW3Zjc11bbWV0aG9kXSA9IGYK
ICAgICAgICByZXR1cm4gZgogICAgcmV0dXJuIGRlY29yYXRlCgoKZGVmIHJ1
bl9jb21tYW5kKGNvbW1hbmRzLCBhcmdzLCBjd2Q9Tm9uZSwgdmVyYm9zZT1G
YWxzZSwgaGlkZV9zdGRlcnI9RmFsc2UsCiAgICAgICAgICAgICAgICBlbnY9
Tm9uZSk6CiAgICAiIiJDYWxsIHRoZSBnaXZlbiBjb21tYW5kKHMpLiIiIgog
ICAgYXNzZXJ0IGlzaW5zdGFuY2UoY29tbWFuZHMsIGxpc3QpCiAgICBwID0g
Tm9uZQogICAgZm9yIGMgaW4gY29tbWFuZHM6CiAgICAgICAgdHJ5OgogICAg
ICAgICAgICBkaXNwY21kID0gc3RyKFtjXSArIGFyZ3MpCiAgICAgICAgICAg
ICMgcmVtZW1iZXIgc2hlbGw9RmFsc2UsIHNvIHVzZSBnaXQuY21kIG9uIHdp
bmRvd3MsIG5vdCBqdXN0IGdpdAogICAgICAgICAgICBwID0gc3VicHJvY2Vz
cy5Qb3BlbihbY10gKyBhcmdzLCBjd2Q9Y3dkLCBlbnY9ZW52LAogICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICBzdGRvdXQ9c3VicHJvY2Vzcy5Q
SVBFLAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBzdGRlcnI9
KHN1YnByb2Nlc3MuUElQRSBpZiBoaWRlX3N0ZGVycgogICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgIGVsc2UgTm9uZSkpCiAgICAg
ICAgICAgIGJyZWFrCiAgICAgICAgZXhjZXB0IEVudmlyb25tZW50RXJyb3I6
CiAgICAgICAgICAgIGUgPSBzeXMuZXhjX2luZm8oKVsxXQogICAgICAgICAg
ICBpZiBlLmVycm5vID09IGVycm5vLkVOT0VOVDoKICAgICAgICAgICAgICAg
IGNvbnRpbnVlCiAgICAgICAgICAgIGlmIHZlcmJvc2U6CiAgICAgICAgICAg
ICAgICBwcmludCgidW5hYmxlIHRvIHJ1biAlJXMiICUlIGRpc3BjbWQpCiAg
ICAgICAgICAgICAgICBwcmludChlKQogICAgICAgICAgICByZXR1cm4gTm9u
ZSwgTm9uZQogICAgZWxzZToKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAg
ICAgICBwcmludCgidW5hYmxlIHRvIGZpbmQgY29tbWFuZCwgdHJpZWQgJSVz
IiAlJSAoY29tbWFuZHMsKSkKICAgICAgICByZXR1cm4gTm9uZSwgTm9uZQog
ICAgc3Rkb3V0ID0gcC5jb21tdW5pY2F0ZSgpWzBdLnN0cmlwKCkuZGVjb2Rl
KCkKICAgIGlmIHAucmV0dXJuY29kZSAhPSAwOgogICAgICAgIGlmIHZlcmJv
c2U6CiAgICAgICAgICAgIHByaW50KCJ1bmFibGUgdG8gcnVuICUlcyAoZXJy
b3IpIiAlJSBkaXNwY21kKQogICAgICAgICAgICBwcmludCgic3Rkb3V0IHdh
cyAlJXMiICUlIHN0ZG91dCkKICAgICAgICByZXR1cm4gTm9uZSwgcC5yZXR1
cm5jb2RlCiAgICByZXR1cm4gc3Rkb3V0LCBwLnJldHVybmNvZGUKCgpkZWYg
dmVyc2lvbnNfZnJvbV9wYXJlbnRkaXIocGFyZW50ZGlyX3ByZWZpeCwgcm9v
dCwgdmVyYm9zZSk6CiAgICAiIiJUcnkgdG8gZGV0ZXJtaW5lIHRoZSB2ZXJz
aW9uIGZyb20gdGhlIHBhcmVudCBkaXJlY3RvcnkgbmFtZS4KCiAgICBTb3Vy
Y2UgdGFyYmFsbHMgY29udmVudGlvbmFsbHkgdW5wYWNrIGludG8gYSBkaXJl
Y3RvcnkgdGhhdCBpbmNsdWRlcyBib3RoCiAgICB0aGUgcHJvamVjdCBuYW1l
IGFuZCBhIHZlcnNpb24gc3RyaW5nLiBXZSB3aWxsIGFsc28gc3VwcG9ydCBz
ZWFyY2hpbmcgdXAKICAgIHR3byBkaXJlY3RvcnkgbGV2ZWxzIGZvciBhbiBh
cHByb3ByaWF0ZWx5IG5hbWVkIHBhcmVudCBkaXJlY3RvcnkKICAgICIiIgog
ICAgcm9vdGRpcnMgPSBbXQoKICAgIGZvciBpIGluIHJhbmdlKDMpOgogICAg
ICAgIGRpcm5hbWUgPSBvcy5wYXRoLmJhc2VuYW1lKHJvb3QpCiAgICAgICAg
aWYgZGlybmFtZS5zdGFydHN3aXRoKHBhcmVudGRpcl9wcmVmaXgpOgogICAg
ICAgICAgICByZXR1cm4geyJ2ZXJzaW9uIjogZGlybmFtZVtsZW4ocGFyZW50
ZGlyX3ByZWZpeCk6XSwKICAgICAgICAgICAgICAgICAgICAiZnVsbC1yZXZp
c2lvbmlkIjogTm9uZSwKICAgICAgICAgICAgICAgICAgICAiZGlydHkiOiBG
YWxzZSwgImVycm9yIjogTm9uZSwgImRhdGUiOiBOb25lfQogICAgICAgIGVs
c2U6CiAgICAgICAgICAgIHJvb3RkaXJzLmFwcGVuZChyb290KQogICAgICAg
ICAgICByb290ID0gb3MucGF0aC5kaXJuYW1lKHJvb3QpICAjIHVwIGEgbGV2
ZWwKCiAgICBpZiB2ZXJib3NlOgogICAgICAgIHByaW50KCJUcmllZCBkaXJl
Y3RvcmllcyAlJXMgYnV0IG5vbmUgc3RhcnRlZCB3aXRoIHByZWZpeCAlJXMi
ICUlCiAgICAgICAgICAgICAgKHN0cihyb290ZGlycyksIHBhcmVudGRpcl9w
cmVmaXgpKQogICAgcmFpc2UgTm90VGhpc01ldGhvZCgicm9vdGRpciBkb2Vz
bid0IHN0YXJ0IHdpdGggcGFyZW50ZGlyX3ByZWZpeCIpCgoKQHJlZ2lzdGVy
X3Zjc19oYW5kbGVyKCJnaXQiLCAiZ2V0X2tleXdvcmRzIikKZGVmIGdpdF9n
ZXRfa2V5d29yZHModmVyc2lvbmZpbGVfYWJzKToKICAgICIiIkV4dHJhY3Qg
dmVyc2lvbiBpbmZvcm1hdGlvbiBmcm9tIHRoZSBnaXZlbiBmaWxlLiIiIgog
ICAgIyB0aGUgY29kZSBlbWJlZGRlZCBpbiBfdmVyc2lvbi5weSBjYW4ganVz
dCBmZXRjaCB0aGUgdmFsdWUgb2YgdGhlc2UKICAgICMga2V5d29yZHMuIFdo
ZW4gdXNlZCBmcm9tIHNldHVwLnB5LCB3ZSBkb24ndCB3YW50IHRvIGltcG9y
dCBfdmVyc2lvbi5weSwKICAgICMgc28gd2UgZG8gaXQgd2l0aCBhIHJlZ2V4
cCBpbnN0ZWFkLiBUaGlzIGZ1bmN0aW9uIGlzIG5vdCB1c2VkIGZyb20KICAg
ICMgX3ZlcnNpb24ucHkuCiAgICBrZXl3b3JkcyA9IHt9CiAgICB0cnk6CiAg
ICAgICAgZiA9IG9wZW4odmVyc2lvbmZpbGVfYWJzLCAiciIpCiAgICAgICAg
Zm9yIGxpbmUgaW4gZi5yZWFkbGluZXMoKToKICAgICAgICAgICAgaWYgbGlu
ZS5zdHJpcCgpLnN0YXJ0c3dpdGgoImdpdF9yZWZuYW1lcyA9Iik6CiAgICAg
ICAgICAgICAgICBtbyA9IHJlLnNlYXJjaChyJz1ccyoiKC4qKSInLCBsaW5l
KQogICAgICAgICAgICAgICAgaWYgbW86CiAgICAgICAgICAgICAgICAgICAg
a2V5d29yZHNbInJlZm5hbWVzIl0gPSBtby5ncm91cCgxKQogICAgICAgICAg
ICBpZiBsaW5lLnN0cmlwKCkuc3RhcnRzd2l0aCgiZ2l0X2Z1bGwgPSIpOgog
ICAgICAgICAgICAgICAgbW8gPSByZS5zZWFyY2gocic9XHMqIiguKikiJywg
bGluZSkKICAgICAgICAgICAgICAgIGlmIG1vOgogICAgICAgICAgICAgICAg
ICAgIGtleXdvcmRzWyJmdWxsIl0gPSBtby5ncm91cCgxKQogICAgICAgICAg
ICBpZiBsaW5lLnN0cmlwKCkuc3RhcnRzd2l0aCgiZ2l0X2RhdGUgPSIpOgog
ICAgICAgICAgICAgICAgbW8gPSByZS5zZWFyY2gocic9XHMqIiguKikiJywg
bGluZSkKICAgICAgICAgICAgICAgIGlmIG1vOgogICAgICAgICAgICAgICAg
ICAgIGtleXdvcmRzWyJkYXRlIl0gPSBtby5ncm91cCgxKQogICAgICAgIGYu
Y2xvc2UoKQogICAgZXhjZXB0IEVudmlyb25tZW50RXJyb3I6CiAgICAgICAg
cGFzcwogICAgcmV0dXJuIGtleXdvcmRzCgoKQHJlZ2lzdGVyX3Zjc19oYW5k
bGVyKCJnaXQiLCAia2V5d29yZHMiKQpkZWYgZ2l0X3ZlcnNpb25zX2Zyb21f
a2V5d29yZHMoa2V5d29yZHMsIHRhZ19wcmVmaXgsIHZlcmJvc2UpOgogICAg
IiIiR2V0IHZlcnNpb24gaW5mb3JtYXRpb24gZnJvbSBnaXQga2V5d29yZHMu
IiIiCiAgICBpZiBub3Qga2V5d29yZHM6CiAgICAgICAgcmFpc2UgTm90VGhp
c01ldGhvZCgibm8ga2V5d29yZHMgYXQgYWxsLCB3ZWlyZCIpCiAgICBkYXRl
ID0ga2V5d29yZHMuZ2V0KCJkYXRlIikKICAgIGlmIGRhdGUgaXMgbm90IE5v
bmU6CiAgICAgICAgIyBVc2Ugb25seSB0aGUgbGFzdCBsaW5lLiAgUHJldmlv
dXMgbGluZXMgbWF5IGNvbnRhaW4gR1BHIHNpZ25hdHVyZQogICAgICAgICMg
aW5mb3JtYXRpb24uCiAgICAgICAgZGF0ZSA9IGRhdGUuc3BsaXRsaW5lcygp
Wy0xXQoKICAgICAgICAjIGdpdC0yLjIuMCBhZGRlZCAiJSVjSSIsIHdoaWNo
IGV4cGFuZHMgdG8gYW4gSVNPLTg2MDEgLWNvbXBsaWFudAogICAgICAgICMg
ZGF0ZXN0YW1wLiBIb3dldmVyIHdlIHByZWZlciAiJSVjaSIgKHdoaWNoIGV4
cGFuZHMgdG8gYW4gIklTTy04NjAxCiAgICAgICAgIyAtbGlrZSIgc3RyaW5n
LCB3aGljaCB3ZSBtdXN0IHRoZW4gZWRpdCB0byBtYWtlIGNvbXBsaWFudCks
IGJlY2F1c2UKICAgICAgICAjIGl0J3MgYmVlbiBhcm91bmQgc2luY2UgZ2l0
LTEuNS4zLCBhbmQgaXQncyB0b28gZGlmZmljdWx0IHRvCiAgICAgICAgIyBk
aXNjb3ZlciB3aGljaCB2ZXJzaW9uIHdlJ3JlIHVzaW5nLCBvciB0byB3b3Jr
IGFyb3VuZCB1c2luZyBhbgogICAgICAgICMgb2xkZXIgb25lLgogICAgICAg
IGRhdGUgPSBkYXRlLnN0cmlwKCkucmVwbGFjZSgiICIsICJUIiwgMSkucmVw
bGFjZSgiICIsICIiLCAxKQogICAgcmVmbmFtZXMgPSBrZXl3b3Jkc1sicmVm
bmFtZXMiXS5zdHJpcCgpCiAgICBpZiByZWZuYW1lcy5zdGFydHN3aXRoKCIk
Rm9ybWF0Iik6CiAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAgICAgcHJp
bnQoImtleXdvcmRzIGFyZSB1bmV4cGFuZGVkLCBub3QgdXNpbmciKQogICAg
ICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoInVuZXhwYW5kZWQga2V5d29yZHMs
IG5vdCBhIGdpdC1hcmNoaXZlIHRhcmJhbGwiKQogICAgcmVmcyA9IHNldChb
ci5zdHJpcCgpIGZvciByIGluIHJlZm5hbWVzLnN0cmlwKCIoKSIpLnNwbGl0
KCIsIildKQogICAgIyBzdGFydGluZyBpbiBnaXQtMS44LjMsIHRhZ3MgYXJl
IGxpc3RlZCBhcyAidGFnOiBmb28tMS4wIiBpbnN0ZWFkIG9mCiAgICAjIGp1
c3QgImZvby0xLjAiLiBJZiB3ZSBzZWUgYSAidGFnOiAiIHByZWZpeCwgcHJl
ZmVyIHRob3NlLgogICAgVEFHID0gInRhZzogIgogICAgdGFncyA9IHNldChb
cltsZW4oVEFHKTpdIGZvciByIGluIHJlZnMgaWYgci5zdGFydHN3aXRoKFRB
RyldKQogICAgaWYgbm90IHRhZ3M6CiAgICAgICAgIyBFaXRoZXIgd2UncmUg
dXNpbmcgZ2l0IDwgMS44LjMsIG9yIHRoZXJlIHJlYWxseSBhcmUgbm8gdGFn
cy4gV2UgdXNlCiAgICAgICAgIyBhIGhldXJpc3RpYzogYXNzdW1lIGFsbCB2
ZXJzaW9uIHRhZ3MgaGF2ZSBhIGRpZ2l0LiBUaGUgb2xkIGdpdCAlJWQKICAg
ICAgICAjIGV4cGFuc2lvbiBiZWhhdmVzIGxpa2UgZ2l0IGxvZyAtLWRlY29y
YXRlPXNob3J0IGFuZCBzdHJpcHMgb3V0IHRoZQogICAgICAgICMgcmVmcy9o
ZWFkcy8gYW5kIHJlZnMvdGFncy8gcHJlZml4ZXMgdGhhdCB3b3VsZCBsZXQg
dXMgZGlzdGluZ3Vpc2gKICAgICAgICAjIGJldHdlZW4gYnJhbmNoZXMgYW5k
IHRhZ3MuIEJ5IGlnbm9yaW5nIHJlZm5hbWVzIHdpdGhvdXQgZGlnaXRzLCB3
ZQogICAgICAgICMgZmlsdGVyIG91dCBtYW55IGNvbW1vbiBicmFuY2ggbmFt
ZXMgbGlrZSAicmVsZWFzZSIgYW5kCiAgICAgICAgIyAic3RhYmlsaXphdGlv
biIsIGFzIHdlbGwgYXMgIkhFQUQiIGFuZCAibWFzdGVyIi4KICAgICAgICB0
YWdzID0gc2V0KFtyIGZvciByIGluIHJlZnMgaWYgcmUuc2VhcmNoKHInXGQn
LCByKV0pCiAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAgICAgcHJpbnQo
ImRpc2NhcmRpbmcgJyUlcycsIG5vIGRpZ2l0cyIgJSUgIiwiLmpvaW4ocmVm
cyAtIHRhZ3MpKQogICAgaWYgdmVyYm9zZToKICAgICAgICBwcmludCgibGlr
ZWx5IHRhZ3M6ICUlcyIgJSUgIiwiLmpvaW4oc29ydGVkKHRhZ3MpKSkKICAg
IGZvciByZWYgaW4gc29ydGVkKHRhZ3MpOgogICAgICAgICMgc29ydGluZyB3
aWxsIHByZWZlciBlLmcuICIyLjAiIG92ZXIgIjIuMHJjMSIKICAgICAgICBp
ZiByZWYuc3RhcnRzd2l0aCh0YWdfcHJlZml4KToKICAgICAgICAgICAgciA9
IHJlZltsZW4odGFnX3ByZWZpeCk6XQogICAgICAgICAgICBpZiB2ZXJib3Nl
OgogICAgICAgICAgICAgICAgcHJpbnQoInBpY2tpbmcgJSVzIiAlJSByKQog
ICAgICAgICAgICByZXR1cm4geyJ2ZXJzaW9uIjogciwKICAgICAgICAgICAg
ICAgICAgICAiZnVsbC1yZXZpc2lvbmlkIjoga2V5d29yZHNbImZ1bGwiXS5z
dHJpcCgpLAogICAgICAgICAgICAgICAgICAgICJkaXJ0eSI6IEZhbHNlLCAi
ZXJyb3IiOiBOb25lLAogICAgICAgICAgICAgICAgICAgICJkYXRlIjogZGF0
ZX0KICAgICMgbm8gc3VpdGFibGUgdGFncywgc28gdmVyc2lvbiBpcyAiMCt1
bmtub3duIiwgYnV0IGZ1bGwgaGV4IGlzIHN0aWxsIHRoZXJlCiAgICBpZiB2
ZXJib3NlOgogICAgICAgIHByaW50KCJubyBzdWl0YWJsZSB0YWdzLCB1c2lu
ZyB1bmtub3duICsgZnVsbCByZXZpc2lvbiBpZCIpCiAgICByZXR1cm4geyJ2
ZXJzaW9uIjogIjArdW5rbm93biIsCiAgICAgICAgICAgICJmdWxsLXJldmlz
aW9uaWQiOiBrZXl3b3Jkc1siZnVsbCJdLnN0cmlwKCksCiAgICAgICAgICAg
ICJkaXJ0eSI6IEZhbHNlLCAiZXJyb3IiOiAibm8gc3VpdGFibGUgdGFncyIs
ICJkYXRlIjogTm9uZX0KCgpAcmVnaXN0ZXJfdmNzX2hhbmRsZXIoImdpdCIs
ICJwaWVjZXNfZnJvbV92Y3MiKQpkZWYgZ2l0X3BpZWNlc19mcm9tX3Zjcyh0
YWdfcHJlZml4LCByb290LCB2ZXJib3NlLCBydW5fY29tbWFuZD1ydW5fY29t
bWFuZCk6CiAgICAiIiJHZXQgdmVyc2lvbiBmcm9tICdnaXQgZGVzY3JpYmUn
IGluIHRoZSByb290IG9mIHRoZSBzb3VyY2UgdHJlZS4KCiAgICBUaGlzIG9u
bHkgZ2V0cyBjYWxsZWQgaWYgdGhlIGdpdC1hcmNoaXZlICdzdWJzdCcga2V5
d29yZHMgd2VyZSAqbm90KgogICAgZXhwYW5kZWQsIGFuZCBfdmVyc2lvbi5w
eSBoYXNuJ3QgYWxyZWFkeSBiZWVuIHJld3JpdHRlbiB3aXRoIGEgc2hvcnQK
ICAgIHZlcnNpb24gc3RyaW5nLCBtZWFuaW5nIHdlJ3JlIGluc2lkZSBhIGNo
ZWNrZWQgb3V0IHNvdXJjZSB0cmVlLgogICAgIiIiCiAgICBHSVRTID0gWyJn
aXQiXQogICAgaWYgc3lzLnBsYXRmb3JtID09ICJ3aW4zMiI6CiAgICAgICAg
R0lUUyA9IFsiZ2l0LmNtZCIsICJnaXQuZXhlIl0KCiAgICBvdXQsIHJjID0g
cnVuX2NvbW1hbmQoR0lUUywgWyJyZXYtcGFyc2UiLCAiLS1naXQtZGlyIl0s
IGN3ZD1yb290LAogICAgICAgICAgICAgICAgICAgICAgICAgIGhpZGVfc3Rk
ZXJyPVRydWUpCiAgICBpZiByYyAhPSAwOgogICAgICAgIGlmIHZlcmJvc2U6
CiAgICAgICAgICAgIHByaW50KCJEaXJlY3RvcnkgJSVzIG5vdCB1bmRlciBn
aXQgY29udHJvbCIgJSUgcm9vdCkKICAgICAgICByYWlzZSBOb3RUaGlzTWV0
aG9kKCInZ2l0IHJldi1wYXJzZSAtLWdpdC1kaXInIHJldHVybmVkIGVycm9y
IikKCiAgICAjIGlmIHRoZXJlIGlzIGEgdGFnIG1hdGNoaW5nIHRhZ19wcmVm
aXgsIHRoaXMgeWllbGRzIFRBRy1OVU0tZ0hFWFstZGlydHldCiAgICAjIGlm
IHRoZXJlIGlzbid0IG9uZSwgdGhpcyB5aWVsZHMgSEVYWy1kaXJ0eV0gKG5v
IE5VTSkKICAgIGRlc2NyaWJlX291dCwgcmMgPSBydW5fY29tbWFuZChHSVRT
LCBbImRlc2NyaWJlIiwgIi0tdGFncyIsICItLWRpcnR5IiwKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIi0tYWx3YXlzIiwg
Ii0tbG9uZyIsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICItLW1hdGNoIiwgIiUlcyoiICUlIHRhZ19wcmVmaXhdLAogICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIGN3ZD1yb290KQogICAg
IyAtLWxvbmcgd2FzIGFkZGVkIGluIGdpdC0xLjUuNQogICAgaWYgZGVzY3Jp
YmVfb3V0IGlzIE5vbmU6CiAgICAgICAgcmFpc2UgTm90VGhpc01ldGhvZCgi
J2dpdCBkZXNjcmliZScgZmFpbGVkIikKICAgIGRlc2NyaWJlX291dCA9IGRl
c2NyaWJlX291dC5zdHJpcCgpCiAgICBmdWxsX291dCwgcmMgPSBydW5fY29t
bWFuZChHSVRTLCBbInJldi1wYXJzZSIsICJIRUFEIl0sIGN3ZD1yb290KQog
ICAgaWYgZnVsbF9vdXQgaXMgTm9uZToKICAgICAgICByYWlzZSBOb3RUaGlz
TWV0aG9kKCInZ2l0IHJldi1wYXJzZScgZmFpbGVkIikKICAgIGZ1bGxfb3V0
ID0gZnVsbF9vdXQuc3RyaXAoKQoKICAgIHBpZWNlcyA9IHt9CiAgICBwaWVj
ZXNbImxvbmciXSA9IGZ1bGxfb3V0CiAgICBwaWVjZXNbInNob3J0Il0gPSBm
dWxsX291dFs6N10gICMgbWF5YmUgaW1wcm92ZWQgbGF0ZXIKICAgIHBpZWNl
c1siZXJyb3IiXSA9IE5vbmUKCiAgICAjIHBhcnNlIGRlc2NyaWJlX291dC4g
SXQgd2lsbCBiZSBsaWtlIFRBRy1OVU0tZ0hFWFstZGlydHldIG9yIEhFWFst
ZGlydHldCiAgICAjIFRBRyBtaWdodCBoYXZlIGh5cGhlbnMuCiAgICBnaXRf
ZGVzY3JpYmUgPSBkZXNjcmliZV9vdXQKCiAgICAjIGxvb2sgZm9yIC1kaXJ0
eSBzdWZmaXgKICAgIGRpcnR5ID0gZ2l0X2Rlc2NyaWJlLmVuZHN3aXRoKCIt
ZGlydHkiKQogICAgcGllY2VzWyJkaXJ0eSJdID0gZGlydHkKICAgIGlmIGRp
cnR5OgogICAgICAgIGdpdF9kZXNjcmliZSA9IGdpdF9kZXNjcmliZVs6Z2l0
X2Rlc2NyaWJlLnJpbmRleCgiLWRpcnR5IildCgogICAgIyBub3cgd2UgaGF2
ZSBUQUctTlVNLWdIRVggb3IgSEVYCgogICAgaWYgIi0iIGluIGdpdF9kZXNj
cmliZToKICAgICAgICAjIFRBRy1OVU0tZ0hFWAogICAgICAgIG1vID0gcmUu
c2VhcmNoKHInXiguKyktKFxkKyktZyhbMC05YS1mXSspJCcsIGdpdF9kZXNj
cmliZSkKICAgICAgICBpZiBub3QgbW86CiAgICAgICAgICAgICMgdW5wYXJz
ZWFibGUuIE1heWJlIGdpdC1kZXNjcmliZSBpcyBtaXNiZWhhdmluZz8KICAg
ICAgICAgICAgcGllY2VzWyJlcnJvciJdID0gKCJ1bmFibGUgdG8gcGFyc2Ug
Z2l0LWRlc2NyaWJlIG91dHB1dDogJyUlcyciCiAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAlJSBkZXNjcmliZV9vdXQpCiAgICAgICAgICAgIHJl
dHVybiBwaWVjZXMKCiAgICAgICAgIyB0YWcKICAgICAgICBmdWxsX3RhZyA9
IG1vLmdyb3VwKDEpCiAgICAgICAgaWYgbm90IGZ1bGxfdGFnLnN0YXJ0c3dp
dGgodGFnX3ByZWZpeCk6CiAgICAgICAgICAgIGlmIHZlcmJvc2U6CiAgICAg
ICAgICAgICAgICBmbXQgPSAidGFnICclJXMnIGRvZXNuJ3Qgc3RhcnQgd2l0
aCBwcmVmaXggJyUlcyciCiAgICAgICAgICAgICAgICBwcmludChmbXQgJSUg
KGZ1bGxfdGFnLCB0YWdfcHJlZml4KSkKICAgICAgICAgICAgcGllY2VzWyJl
cnJvciJdID0gKCJ0YWcgJyUlcycgZG9lc24ndCBzdGFydCB3aXRoIHByZWZp
eCAnJSVzJyIKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICUlIChm
dWxsX3RhZywgdGFnX3ByZWZpeCkpCiAgICAgICAgICAgIHJldHVybiBwaWVj
ZXMKICAgICAgICBwaWVjZXNbImNsb3Nlc3QtdGFnIl0gPSBmdWxsX3RhZ1ts
ZW4odGFnX3ByZWZpeCk6XQoKICAgICAgICAjIGRpc3RhbmNlOiBudW1iZXIg
b2YgY29tbWl0cyBzaW5jZSB0YWcKICAgICAgICBwaWVjZXNbImRpc3RhbmNl
Il0gPSBpbnQobW8uZ3JvdXAoMikpCgogICAgICAgICMgY29tbWl0OiBzaG9y
dCBoZXggcmV2aXNpb24gSUQKICAgICAgICBwaWVjZXNbInNob3J0Il0gPSBt
by5ncm91cCgzKQoKICAgIGVsc2U6CiAgICAgICAgIyBIRVg6IG5vIHRhZ3MK
ICAgICAgICBwaWVjZXNbImNsb3Nlc3QtdGFnIl0gPSBOb25lCiAgICAgICAg
Y291bnRfb3V0LCByYyA9IHJ1bl9jb21tYW5kKEdJVFMsIFsicmV2LWxpc3Qi
LCAiSEVBRCIsICItLWNvdW50Il0sCiAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIGN3ZD1yb290KQogICAgICAgIHBpZWNlc1siZGlzdGFu
Y2UiXSA9IGludChjb3VudF9vdXQpICAjIHRvdGFsIG51bWJlciBvZiBjb21t
aXRzCgogICAgIyBjb21taXQgZGF0ZTogc2VlIElTTy04NjAxIGNvbW1lbnQg
aW4gZ2l0X3ZlcnNpb25zX2Zyb21fa2V5d29yZHMoKQogICAgZGF0ZSA9IHJ1
bl9jb21tYW5kKEdJVFMsIFsic2hvdyIsICItcyIsICItLWZvcm1hdD0lJWNp
IiwgIkhFQUQiXSwKICAgICAgICAgICAgICAgICAgICAgICBjd2Q9cm9vdClb
MF0uc3RyaXAoKQogICAgIyBVc2Ugb25seSB0aGUgbGFzdCBsaW5lLiAgUHJl
dmlvdXMgbGluZXMgbWF5IGNvbnRhaW4gR1BHIHNpZ25hdHVyZQogICAgIyBp
bmZvcm1hdGlvbi4KICAgIGRhdGUgPSBkYXRlLnNwbGl0bGluZXMoKVstMV0K
ICAgIHBpZWNlc1siZGF0ZSJdID0gZGF0ZS5zdHJpcCgpLnJlcGxhY2UoIiAi
LCAiVCIsIDEpLnJlcGxhY2UoIiAiLCAiIiwgMSkKCiAgICByZXR1cm4gcGll
Y2VzCgoKZGVmIHBsdXNfb3JfZG90KHBpZWNlcyk6CiAgICAiIiJSZXR1cm4g
YSArIGlmIHdlIGRvbid0IGFscmVhZHkgaGF2ZSBvbmUsIGVsc2UgcmV0dXJu
IGEgLiIiIgogICAgaWYgIisiIGluIHBpZWNlcy5nZXQoImNsb3Nlc3QtdGFn
IiwgIiIpOgogICAgICAgIHJldHVybiAiLiIKICAgIHJldHVybiAiKyIKCgpk
ZWYgcmVuZGVyX3BlcDQ0MChwaWVjZXMpOgogICAgIiIiQnVpbGQgdXAgdmVy
c2lvbiBzdHJpbmcsIHdpdGggcG9zdC1yZWxlYXNlICJsb2NhbCB2ZXJzaW9u
IGlkZW50aWZpZXIiLgoKICAgIE91ciBnb2FsOiBUQUdbK0RJU1RBTkNFLmdI
RVhbLmRpcnR5XV0gLiBOb3RlIHRoYXQgaWYgeW91CiAgICBnZXQgYSB0YWdn
ZWQgYnVpbGQgYW5kIHRoZW4gZGlydHkgaXQsIHlvdSdsbCBnZXQgVEFHKzAu
Z0hFWC5kaXJ0eQoKICAgIEV4Y2VwdGlvbnM6CiAgICAxOiBubyB0YWdzLiBn
aXRfZGVzY3JpYmUgd2FzIGp1c3QgSEVYLiAwK3VudGFnZ2VkLkRJU1RBTkNF
LmdIRVhbLmRpcnR5XQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3Qt
dGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFn
Il0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl0gb3IgcGllY2VzWyJk
aXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCArPSBwbHVzX29yX2RvdChw
aWVjZXMpCiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIlJWQuZyUlcyIgJSUg
KHBpZWNlc1siZGlzdGFuY2UiXSwgcGllY2VzWyJzaG9ydCJdKQogICAgICAg
ICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAgICAgICByZW5k
ZXJlZCArPSAiLmRpcnR5IgogICAgZWxzZToKICAgICAgICAjIGV4Y2VwdGlv
biAjMQogICAgICAgIHJlbmRlcmVkID0gIjArdW50YWdnZWQuJSVkLmclJXMi
ICUlIChwaWVjZXNbImRpc3RhbmNlIl0sCiAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgIHBpZWNlc1sic2hvcnQiXSkKICAgICAg
ICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9
ICIuZGlydHkiCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyX3Bl
cDQ0MF9wcmUocGllY2VzKToKICAgICIiIlRBR1sucG9zdDAuZGV2RElTVEFO
Q0VdIC0tIE5vIC1kaXJ0eS4KCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8g
dGFncy4gMC5wb3N0MC5kZXZESVNUQU5DRQogICAgIiIiCiAgICBpZiBwaWVj
ZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNb
ImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl06
CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIucG9zdDAuZGV2JSVkIiAlJSBw
aWVjZXNbImRpc3RhbmNlIl0KICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRp
b24gIzEKICAgICAgICByZW5kZXJlZCA9ICIwLnBvc3QwLmRldiUlZCIgJSUg
cGllY2VzWyJkaXN0YW5jZSJdCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYg
cmVuZGVyX3BlcDQ0MF9wb3N0KHBpZWNlcyk6CiAgICAiIiJUQUdbLnBvc3RE
SVNUQU5DRVsuZGV2MF0rZ0hFWF0gLgoKICAgIFRoZSAiLmRldjAiIG1lYW5z
IGRpcnR5LiBOb3RlIHRoYXQgLmRldjAgc29ydHMgYmFja3dhcmRzCiAgICAo
YSBkaXJ0eSB0cmVlIHdpbGwgYXBwZWFyICJvbGRlciIgdGhhbiB0aGUgY29y
cmVzcG9uZGluZyBjbGVhbiBvbmUpLAogICAgYnV0IHlvdSBzaG91bGRuJ3Qg
YmUgcmVsZWFzaW5nIHNvZnR3YXJlIHdpdGggLWRpcnR5IGFueXdheXMuCgog
ICAgRXhjZXB0aW9uczoKICAgIDE6IG5vIHRhZ3MuIDAucG9zdERJU1RBTkNF
Wy5kZXYwXQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06
CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0KICAg
ICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl0gb3IgcGllY2VzWyJkaXJ0eSJd
OgogICAgICAgICAgICByZW5kZXJlZCArPSAiLnBvc3QlJWQiICUlIHBpZWNl
c1siZGlzdGFuY2UiXQogICAgICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06
CiAgICAgICAgICAgICAgICByZW5kZXJlZCArPSAiLmRldjAiCiAgICAgICAg
ICAgIHJlbmRlcmVkICs9IHBsdXNfb3JfZG90KHBpZWNlcykKICAgICAgICAg
ICAgcmVuZGVyZWQgKz0gImclJXMiICUlIHBpZWNlc1sic2hvcnQiXQogICAg
ZWxzZToKICAgICAgICAjIGV4Y2VwdGlvbiAjMQogICAgICAgIHJlbmRlcmVk
ID0gIjAucG9zdCUlZCIgJSUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICAgICAg
aWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCArPSAi
LmRldjAiCiAgICAgICAgcmVuZGVyZWQgKz0gIitnJSVzIiAlJSBwaWVjZXNb
InNob3J0Il0KICAgIHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJfcGVw
NDQwX29sZChwaWVjZXMpOgogICAgIiIiVEFHWy5wb3N0RElTVEFOQ0VbLmRl
djBdXSAuCgogICAgVGhlICIuZGV2MCIgbWVhbnMgZGlydHkuCgogICAgRXhj
ZXB0aW9uczoKICAgIDE6IG5vIHRhZ3MuIDAucG9zdERJU1RBTkNFWy5kZXYw
XQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06CiAgICAg
ICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0KICAgICAgICBp
ZiBwaWVjZXNbImRpc3RhbmNlIl0gb3IgcGllY2VzWyJkaXJ0eSJdOgogICAg
ICAgICAgICByZW5kZXJlZCArPSAiLnBvc3QlJWQiICUlIHBpZWNlc1siZGlz
dGFuY2UiXQogICAgICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAg
ICAgICAgICAgICByZW5kZXJlZCArPSAiLmRldjAiCiAgICBlbHNlOgogICAg
ICAgICMgZXhjZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSAiMC5wb3N0
JSVkIiAlJSBwaWVjZXNbImRpc3RhbmNlIl0KICAgICAgICBpZiBwaWVjZXNb
ImRpcnR5Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAg
IHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJfZ2l0X2Rlc2NyaWJlKHBp
ZWNlcyk6CiAgICAiIiJUQUdbLURJU1RBTkNFLWdIRVhdWy1kaXJ0eV0uCgog
ICAgTGlrZSAnZ2l0IGRlc2NyaWJlIC0tdGFncyAtLWRpcnR5IC0tYWx3YXlz
Jy4KCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8gdGFncy4gSEVYWy1kaXJ0
eV0gIChub3RlOiBubyAnZycgcHJlZml4KQogICAgIiIiCiAgICBpZiBwaWVj
ZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNb
ImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl06
CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICItJSVkLWclJXMiICUlIChwaWVj
ZXNbImRpc3RhbmNlIl0sIHBpZWNlc1sic2hvcnQiXSkKICAgIGVsc2U6CiAg
ICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9IHBpZWNl
c1sic2hvcnQiXQogICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgIHJl
bmRlcmVkICs9ICItZGlydHkiCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYg
cmVuZGVyX2dpdF9kZXNjcmliZV9sb25nKHBpZWNlcyk6CiAgICAiIiJUQUct
RElTVEFOQ0UtZ0hFWFstZGlydHldLgoKICAgIExpa2UgJ2dpdCBkZXNjcmli
ZSAtLXRhZ3MgLS1kaXJ0eSAtLWFsd2F5cyAtbG9uZycuCiAgICBUaGUgZGlz
dGFuY2UvaGFzaCBpcyB1bmNvbmRpdGlvbmFsLgoKICAgIEV4Y2VwdGlvbnM6
CiAgICAxOiBubyB0YWdzLiBIRVhbLWRpcnR5XSAgKG5vdGU6IG5vICdnJyBw
cmVmaXgpCiAgICAiIiIKICAgIGlmIHBpZWNlc1siY2xvc2VzdC10YWciXToK
ICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10YWciXQogICAg
ICAgIHJlbmRlcmVkICs9ICItJSVkLWclJXMiICUlIChwaWVjZXNbImRpc3Rh
bmNlIl0sIHBpZWNlc1sic2hvcnQiXSkKICAgIGVsc2U6CiAgICAgICAgIyBl
eGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1sic2hvcnQi
XQogICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgIHJlbmRlcmVkICs9
ICItZGlydHkiCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyKHBp
ZWNlcywgc3R5bGUpOgogICAgIiIiUmVuZGVyIHRoZSBnaXZlbiB2ZXJzaW9u
IHBpZWNlcyBpbnRvIHRoZSByZXF1ZXN0ZWQgc3R5bGUuIiIiCiAgICBpZiBw
aWVjZXNbImVycm9yIl06CiAgICAgICAgcmV0dXJuIHsidmVyc2lvbiI6ICJ1
bmtub3duIiwKICAgICAgICAgICAgICAgICJmdWxsLXJldmlzaW9uaWQiOiBw
aWVjZXMuZ2V0KCJsb25nIiksCiAgICAgICAgICAgICAgICAiZGlydHkiOiBO
b25lLAogICAgICAgICAgICAgICAgImVycm9yIjogcGllY2VzWyJlcnJvciJd
LAogICAgICAgICAgICAgICAgImRhdGUiOiBOb25lfQoKICAgIGlmIG5vdCBz
dHlsZSBvciBzdHlsZSA9PSAiZGVmYXVsdCI6CiAgICAgICAgc3R5bGUgPSAi
cGVwNDQwIiAgIyB0aGUgZGVmYXVsdAoKICAgIGlmIHN0eWxlID09ICJwZXA0
NDAiOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MChwaWVjZXMp
CiAgICBlbGlmIHN0eWxlID09ICJwZXA0NDAtcHJlIjoKICAgICAgICByZW5k
ZXJlZCA9IHJlbmRlcl9wZXA0NDBfcHJlKHBpZWNlcykKICAgIGVsaWYgc3R5
bGUgPT0gInBlcDQ0MC1wb3N0IjoKICAgICAgICByZW5kZXJlZCA9IHJlbmRl
cl9wZXA0NDBfcG9zdChwaWVjZXMpCiAgICBlbGlmIHN0eWxlID09ICJwZXA0
NDAtb2xkIjoKICAgICAgICByZW5kZXJlZCA9IHJlbmRlcl9wZXA0NDBfb2xk
KHBpZWNlcykKICAgIGVsaWYgc3R5bGUgPT0gImdpdC1kZXNjcmliZSI6CiAg
ICAgICAgcmVuZGVyZWQgPSByZW5kZXJfZ2l0X2Rlc2NyaWJlKHBpZWNlcykK
ICAgIGVsaWYgc3R5bGUgPT0gImdpdC1kZXNjcmliZS1sb25nIjoKICAgICAg
ICByZW5kZXJlZCA9IHJlbmRlcl9naXRfZGVzY3JpYmVfbG9uZyhwaWVjZXMp
CiAgICBlbHNlOgogICAgICAgIHJhaXNlIFZhbHVlRXJyb3IoInVua25vd24g
c3R5bGUgJyUlcyciICUlIHN0eWxlKQoKICAgIHJldHVybiB7InZlcnNpb24i
OiByZW5kZXJlZCwgImZ1bGwtcmV2aXNpb25pZCI6IHBpZWNlc1sibG9uZyJd
LAogICAgICAgICAgICAiZGlydHkiOiBwaWVjZXNbImRpcnR5Il0sICJlcnJv
ciI6IE5vbmUsCiAgICAgICAgICAgICJkYXRlIjogcGllY2VzLmdldCgiZGF0
ZSIpfQoKCmRlZiBnZXRfdmVyc2lvbnMoKToKICAgICIiIkdldCB2ZXJzaW9u
IGluZm9ybWF0aW9uIG9yIHJldHVybiBkZWZhdWx0IGlmIHVuYWJsZSB0byBk
byBzby4iIiIKICAgICMgSSBhbSBpbiBfdmVyc2lvbi5weSwgd2hpY2ggbGl2
ZXMgYXQgUk9PVC9WRVJTSU9ORklMRV9TT1VSQ0UuIElmIHdlIGhhdmUKICAg
ICMgX19maWxlX18sIHdlIGNhbiB3b3JrIGJhY2t3YXJkcyBmcm9tIHRoZXJl
IHRvIHRoZSByb290LiBTb21lCiAgICAjIHB5MmV4ZS9iYmZyZWV6ZS9ub24t
Q1B5dGhvbiBpbXBsZW1lbnRhdGlvbnMgZG9uJ3QgZG8gX19maWxlX18sIGlu
IHdoaWNoCiAgICAjIGNhc2Ugd2UgY2FuIG9ubHkgdXNlIGV4cGFuZGVkIGtl
eXdvcmRzLgoKICAgIGNmZyA9IGdldF9jb25maWcoKQogICAgdmVyYm9zZSA9
IGNmZy52ZXJib3NlCgogICAgdHJ5OgogICAgICAgIHJldHVybiBnaXRfdmVy
c2lvbnNfZnJvbV9rZXl3b3JkcyhnZXRfa2V5d29yZHMoKSwgY2ZnLnRhZ19w
cmVmaXgsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIHZlcmJvc2UpCiAgICBleGNlcHQgTm90VGhpc01ldGhvZDoKICAgICAg
ICBwYXNzCgogICAgdHJ5OgogICAgICAgIHJvb3QgPSBvcy5wYXRoLnJlYWxw
YXRoKF9fZmlsZV9fKQogICAgICAgICMgdmVyc2lvbmZpbGVfc291cmNlIGlz
IHRoZSByZWxhdGl2ZSBwYXRoIGZyb20gdGhlIHRvcCBvZiB0aGUgc291cmNl
CiAgICAgICAgIyB0cmVlICh3aGVyZSB0aGUgLmdpdCBkaXJlY3RvcnkgbWln
aHQgbGl2ZSkgdG8gdGhpcyBmaWxlLiBJbnZlcnQKICAgICAgICAjIHRoaXMg
dG8gZmluZCB0aGUgcm9vdCBmcm9tIF9fZmlsZV9fLgogICAgICAgIGZvciBp
IGluIGNmZy52ZXJzaW9uZmlsZV9zb3VyY2Uuc3BsaXQoJy8nKToKICAgICAg
ICAgICAgcm9vdCA9IG9zLnBhdGguZGlybmFtZShyb290KQogICAgZXhjZXB0
IE5hbWVFcnJvcjoKICAgICAgICByZXR1cm4geyJ2ZXJzaW9uIjogIjArdW5r
bm93biIsICJmdWxsLXJldmlzaW9uaWQiOiBOb25lLAogICAgICAgICAgICAg
ICAgImRpcnR5IjogTm9uZSwKICAgICAgICAgICAgICAgICJlcnJvciI6ICJ1
bmFibGUgdG8gZmluZCByb290IG9mIHNvdXJjZSB0cmVlIiwKICAgICAgICAg
ICAgICAgICJkYXRlIjogTm9uZX0KCiAgICB0cnk6CiAgICAgICAgcGllY2Vz
ID0gZ2l0X3BpZWNlc19mcm9tX3ZjcyhjZmcudGFnX3ByZWZpeCwgcm9vdCwg
dmVyYm9zZSkKICAgICAgICByZXR1cm4gcmVuZGVyKHBpZWNlcywgY2ZnLnN0
eWxlKQogICAgZXhjZXB0IE5vdFRoaXNNZXRob2Q6CiAgICAgICAgcGFzcwoK
ICAgIHRyeToKICAgICAgICBpZiBjZmcucGFyZW50ZGlyX3ByZWZpeDoKICAg
ICAgICAgICAgcmV0dXJuIHZlcnNpb25zX2Zyb21fcGFyZW50ZGlyKGNmZy5w
YXJlbnRkaXJfcHJlZml4LCByb290LCB2ZXJib3NlKQogICAgZXhjZXB0IE5v
dFRoaXNNZXRob2Q6CiAgICAgICAgcGFzcwoKICAgIHJldHVybiB7InZlcnNp
b24iOiAiMCt1bmtub3duIiwgImZ1bGwtcmV2aXNpb25pZCI6IE5vbmUsCiAg
ICAgICAgICAgICJkaXJ0eSI6IE5vbmUsCiAgICAgICAgICAgICJlcnJvciI6
ICJ1bmFibGUgdG8gY29tcHV0ZSB2ZXJzaW9uIiwgImRhdGUiOiBOb25lfQon
JycKCgpAcmVnaXN0ZXJfdmNzX2hhbmRsZXIoImdpdCIsICJnZXRfa2V5d29y
ZHMiKQpkZWYgZ2l0X2dldF9rZXl3b3Jkcyh2ZXJzaW9uZmlsZV9hYnMpOgog
ICAgIiIiRXh0cmFjdCB2ZXJzaW9uIGluZm9ybWF0aW9uIGZyb20gdGhlIGdp
dmVuIGZpbGUuIiIiCiAgICAjIHRoZSBjb2RlIGVtYmVkZGVkIGluIF92ZXJz
aW9uLnB5IGNhbiBqdXN0IGZldGNoIHRoZSB2YWx1ZSBvZiB0aGVzZQogICAg
IyBrZXl3b3Jkcy4gV2hlbiB1c2VkIGZyb20gc2V0dXAucHksIHdlIGRvbid0
IHdhbnQgdG8gaW1wb3J0IF92ZXJzaW9uLnB5LAogICAgIyBzbyB3ZSBkbyBp
dCB3aXRoIGEgcmVnZXhwIGluc3RlYWQuIFRoaXMgZnVuY3Rpb24gaXMgbm90
IHVzZWQgZnJvbQogICAgIyBfdmVyc2lvbi5weS4KICAgIGtleXdvcmRzID0g
e30KICAgIHRyeToKICAgICAgICBmID0gb3Blbih2ZXJzaW9uZmlsZV9hYnMs
ICJyIikKICAgICAgICBmb3IgbGluZSBpbiBmLnJlYWRsaW5lcygpOgogICAg
ICAgICAgICBpZiBsaW5lLnN0cmlwKCkuc3RhcnRzd2l0aCgiZ2l0X3JlZm5h
bWVzID0iKToKICAgICAgICAgICAgICAgIG1vID0gcmUuc2VhcmNoKHInPVxz
KiIoLiopIicsIGxpbmUpCiAgICAgICAgICAgICAgICBpZiBtbzoKICAgICAg
ICAgICAgICAgICAgICBrZXl3b3Jkc1sicmVmbmFtZXMiXSA9IG1vLmdyb3Vw
KDEpCiAgICAgICAgICAgIGlmIGxpbmUuc3RyaXAoKS5zdGFydHN3aXRoKCJn
aXRfZnVsbCA9Iik6CiAgICAgICAgICAgICAgICBtbyA9IHJlLnNlYXJjaChy
Jz1ccyoiKC4qKSInLCBsaW5lKQogICAgICAgICAgICAgICAgaWYgbW86CiAg
ICAgICAgICAgICAgICAgICAga2V5d29yZHNbImZ1bGwiXSA9IG1vLmdyb3Vw
KDEpCiAgICAgICAgICAgIGlmIGxpbmUuc3RyaXAoKS5zdGFydHN3aXRoKCJn
aXRfZGF0ZSA9Iik6CiAgICAgICAgICAgICAgICBtbyA9IHJlLnNlYXJjaChy
Jz1ccyoiKC4qKSInLCBsaW5lKQogICAgICAgICAgICAgICAgaWYgbW86CiAg
ICAgICAgICAgICAgICAgICAga2V5d29yZHNbImRhdGUiXSA9IG1vLmdyb3Vw
KDEpCiAgICAgICAgZi5jbG9zZSgpCiAgICBleGNlcHQgRW52aXJvbm1lbnRF
cnJvcjoKICAgICAgICBwYXNzCiAgICByZXR1cm4ga2V5d29yZHMKCgpAcmVn
aXN0ZXJfdmNzX2hhbmRsZXIoImdpdCIsICJrZXl3b3JkcyIpCmRlZiBnaXRf
dmVyc2lvbnNfZnJvbV9rZXl3b3JkcyhrZXl3b3JkcywgdGFnX3ByZWZpeCwg
dmVyYm9zZSk6CiAgICAiIiJHZXQgdmVyc2lvbiBpbmZvcm1hdGlvbiBmcm9t
IGdpdCBrZXl3b3Jkcy4iIiIKICAgIGlmIG5vdCBrZXl3b3JkczoKICAgICAg
ICByYWlzZSBOb3RUaGlzTWV0aG9kKCJubyBrZXl3b3JkcyBhdCBhbGwsIHdl
aXJkIikKICAgIGRhdGUgPSBrZXl3b3Jkcy5nZXQoImRhdGUiKQogICAgaWYg
ZGF0ZSBpcyBub3QgTm9uZToKICAgICAgICAjIFVzZSBvbmx5IHRoZSBsYXN0
IGxpbmUuICBQcmV2aW91cyBsaW5lcyBtYXkgY29udGFpbiBHUEcgc2lnbmF0
dXJlCiAgICAgICAgIyBpbmZvcm1hdGlvbi4KICAgICAgICBkYXRlID0gZGF0
ZS5zcGxpdGxpbmVzKClbLTFdCgogICAgICAgICMgZ2l0LTIuMi4wIGFkZGVk
ICIlY0kiLCB3aGljaCBleHBhbmRzIHRvIGFuIElTTy04NjAxIC1jb21wbGlh
bnQKICAgICAgICAjIGRhdGVzdGFtcC4gSG93ZXZlciB3ZSBwcmVmZXIgIiVj
aSIgKHdoaWNoIGV4cGFuZHMgdG8gYW4gIklTTy04NjAxCiAgICAgICAgIyAt
bGlrZSIgc3RyaW5nLCB3aGljaCB3ZSBtdXN0IHRoZW4gZWRpdCB0byBtYWtl
IGNvbXBsaWFudCksIGJlY2F1c2UKICAgICAgICAjIGl0J3MgYmVlbiBhcm91
bmQgc2luY2UgZ2l0LTEuNS4zLCBhbmQgaXQncyB0b28gZGlmZmljdWx0IHRv
CiAgICAgICAgIyBkaXNjb3ZlciB3aGljaCB2ZXJzaW9uIHdlJ3JlIHVzaW5n
LCBvciB0byB3b3JrIGFyb3VuZCB1c2luZyBhbgogICAgICAgICMgb2xkZXIg
b25lLgogICAgICAgIGRhdGUgPSBkYXRlLnN0cmlwKCkucmVwbGFjZSgiICIs
ICJUIiwgMSkucmVwbGFjZSgiICIsICIiLCAxKQogICAgcmVmbmFtZXMgPSBr
ZXl3b3Jkc1sicmVmbmFtZXMiXS5zdHJpcCgpCiAgICBpZiByZWZuYW1lcy5z
dGFydHN3aXRoKCIkRm9ybWF0Iik6CiAgICAgICAgaWYgdmVyYm9zZToKICAg
ICAgICAgICAgcHJpbnQoImtleXdvcmRzIGFyZSB1bmV4cGFuZGVkLCBub3Qg
dXNpbmciKQogICAgICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoInVuZXhwYW5k
ZWQga2V5d29yZHMsIG5vdCBhIGdpdC1hcmNoaXZlIHRhcmJhbGwiKQogICAg
cmVmcyA9IHNldChbci5zdHJpcCgpIGZvciByIGluIHJlZm5hbWVzLnN0cmlw
KCIoKSIpLnNwbGl0KCIsIildKQogICAgIyBzdGFydGluZyBpbiBnaXQtMS44
LjMsIHRhZ3MgYXJlIGxpc3RlZCBhcyAidGFnOiBmb28tMS4wIiBpbnN0ZWFk
IG9mCiAgICAjIGp1c3QgImZvby0xLjAiLiBJZiB3ZSBzZWUgYSAidGFnOiAi
IHByZWZpeCwgcHJlZmVyIHRob3NlLgogICAgVEFHID0gInRhZzogIgogICAg
dGFncyA9IHNldChbcltsZW4oVEFHKTpdIGZvciByIGluIHJlZnMgaWYgci5z
dGFydHN3aXRoKFRBRyldKQogICAgaWYgbm90IHRhZ3M6CiAgICAgICAgIyBF
aXRoZXIgd2UncmUgdXNpbmcgZ2l0IDwgMS44LjMsIG9yIHRoZXJlIHJlYWxs
eSBhcmUgbm8gdGFncy4gV2UgdXNlCiAgICAgICAgIyBhIGhldXJpc3RpYzog
YXNzdW1lIGFsbCB2ZXJzaW9uIHRhZ3MgaGF2ZSBhIGRpZ2l0LiBUaGUgb2xk
IGdpdCAlZAogICAgICAgICMgZXhwYW5zaW9uIGJlaGF2ZXMgbGlrZSBnaXQg
bG9nIC0tZGVjb3JhdGU9c2hvcnQgYW5kIHN0cmlwcyBvdXQgdGhlCiAgICAg
ICAgIyByZWZzL2hlYWRzLyBhbmQgcmVmcy90YWdzLyBwcmVmaXhlcyB0aGF0
IHdvdWxkIGxldCB1cyBkaXN0aW5ndWlzaAogICAgICAgICMgYmV0d2VlbiBi
cmFuY2hlcyBhbmQgdGFncy4gQnkgaWdub3JpbmcgcmVmbmFtZXMgd2l0aG91
dCBkaWdpdHMsIHdlCiAgICAgICAgIyBmaWx0ZXIgb3V0IG1hbnkgY29tbW9u
IGJyYW5jaCBuYW1lcyBsaWtlICJyZWxlYXNlIiBhbmQKICAgICAgICAjICJz
dGFiaWxpemF0aW9uIiwgYXMgd2VsbCBhcyAiSEVBRCIgYW5kICJtYXN0ZXIi
LgogICAgICAgIHRhZ3MgPSBzZXQoW3IgZm9yIHIgaW4gcmVmcyBpZiByZS5z
ZWFyY2gocidcZCcsIHIpXSkKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAg
ICAgICBwcmludCgiZGlzY2FyZGluZyAnJXMnLCBubyBkaWdpdHMiICUgIiwi
LmpvaW4ocmVmcyAtIHRhZ3MpKQogICAgaWYgdmVyYm9zZToKICAgICAgICBw
cmludCgibGlrZWx5IHRhZ3M6ICVzIiAlICIsIi5qb2luKHNvcnRlZCh0YWdz
KSkpCiAgICBmb3IgcmVmIGluIHNvcnRlZCh0YWdzKToKICAgICAgICAjIHNv
cnRpbmcgd2lsbCBwcmVmZXIgZS5nLiAiMi4wIiBvdmVyICIyLjByYzEiCiAg
ICAgICAgaWYgcmVmLnN0YXJ0c3dpdGgodGFnX3ByZWZpeCk6CiAgICAgICAg
ICAgIHIgPSByZWZbbGVuKHRhZ19wcmVmaXgpOl0KICAgICAgICAgICAgaWYg
dmVyYm9zZToKICAgICAgICAgICAgICAgIHByaW50KCJwaWNraW5nICVzIiAl
IHIpCiAgICAgICAgICAgIHJldHVybiB7InZlcnNpb24iOiByLAogICAgICAg
ICAgICAgICAgICAgICJmdWxsLXJldmlzaW9uaWQiOiBrZXl3b3Jkc1siZnVs
bCJdLnN0cmlwKCksCiAgICAgICAgICAgICAgICAgICAgImRpcnR5IjogRmFs
c2UsICJlcnJvciI6IE5vbmUsCiAgICAgICAgICAgICAgICAgICAgImRhdGUi
OiBkYXRlfQogICAgIyBubyBzdWl0YWJsZSB0YWdzLCBzbyB2ZXJzaW9uIGlz
ICIwK3Vua25vd24iLCBidXQgZnVsbCBoZXggaXMgc3RpbGwgdGhlcmUKICAg
IGlmIHZlcmJvc2U6CiAgICAgICAgcHJpbnQoIm5vIHN1aXRhYmxlIHRhZ3Ms
IHVzaW5nIHVua25vd24gKyBmdWxsIHJldmlzaW9uIGlkIikKICAgIHJldHVy
biB7InZlcnNpb24iOiAiMCt1bmtub3duIiwKICAgICAgICAgICAgImZ1bGwt
cmV2aXNpb25pZCI6IGtleXdvcmRzWyJmdWxsIl0uc3RyaXAoKSwKICAgICAg
ICAgICAgImRpcnR5IjogRmFsc2UsICJlcnJvciI6ICJubyBzdWl0YWJsZSB0
YWdzIiwgImRhdGUiOiBOb25lfQoKCkByZWdpc3Rlcl92Y3NfaGFuZGxlcigi
Z2l0IiwgInBpZWNlc19mcm9tX3ZjcyIpCmRlZiBnaXRfcGllY2VzX2Zyb21f
dmNzKHRhZ19wcmVmaXgsIHJvb3QsIHZlcmJvc2UsIHJ1bl9jb21tYW5kPXJ1
bl9jb21tYW5kKToKICAgICIiIkdldCB2ZXJzaW9uIGZyb20gJ2dpdCBkZXNj
cmliZScgaW4gdGhlIHJvb3Qgb2YgdGhlIHNvdXJjZSB0cmVlLgoKICAgIFRo
aXMgb25seSBnZXRzIGNhbGxlZCBpZiB0aGUgZ2l0LWFyY2hpdmUgJ3N1YnN0
JyBrZXl3b3JkcyB3ZXJlICpub3QqCiAgICBleHBhbmRlZCwgYW5kIF92ZXJz
aW9uLnB5IGhhc24ndCBhbHJlYWR5IGJlZW4gcmV3cml0dGVuIHdpdGggYSBz
aG9ydAogICAgdmVyc2lvbiBzdHJpbmcsIG1lYW5pbmcgd2UncmUgaW5zaWRl
IGEgY2hlY2tlZCBvdXQgc291cmNlIHRyZWUuCiAgICAiIiIKICAgIEdJVFMg
PSBbImdpdCJdCiAgICBpZiBzeXMucGxhdGZvcm0gPT0gIndpbjMyIjoKICAg
ICAgICBHSVRTID0gWyJnaXQuY21kIiwgImdpdC5leGUiXQoKICAgIG91dCwg
cmMgPSBydW5fY29tbWFuZChHSVRTLCBbInJldi1wYXJzZSIsICItLWdpdC1k
aXIiXSwgY3dkPXJvb3QsCiAgICAgICAgICAgICAgICAgICAgICAgICAgaGlk
ZV9zdGRlcnI9VHJ1ZSkKICAgIGlmIHJjICE9IDA6CiAgICAgICAgaWYgdmVy
Ym9zZToKICAgICAgICAgICAgcHJpbnQoIkRpcmVjdG9yeSAlcyBub3QgdW5k
ZXIgZ2l0IGNvbnRyb2wiICUgcm9vdCkKICAgICAgICByYWlzZSBOb3RUaGlz
TWV0aG9kKCInZ2l0IHJldi1wYXJzZSAtLWdpdC1kaXInIHJldHVybmVkIGVy
cm9yIikKCiAgICAjIGlmIHRoZXJlIGlzIGEgdGFnIG1hdGNoaW5nIHRhZ19w
cmVmaXgsIHRoaXMgeWllbGRzIFRBRy1OVU0tZ0hFWFstZGlydHldCiAgICAj
IGlmIHRoZXJlIGlzbid0IG9uZSwgdGhpcyB5aWVsZHMgSEVYWy1kaXJ0eV0g
KG5vIE5VTSkKICAgIGRlc2NyaWJlX291dCwgcmMgPSBydW5fY29tbWFuZChH
SVRTLCBbImRlc2NyaWJlIiwgIi0tdGFncyIsICItLWRpcnR5IiwKICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIi0tYWx3YXlz
IiwgIi0tbG9uZyIsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICItLW1hdGNoIiwgIiVzKiIgJSB0YWdfcHJlZml4XSwKICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBjd2Q9cm9vdCkKICAg
ICMgLS1sb25nIHdhcyBhZGRlZCBpbiBnaXQtMS41LjUKICAgIGlmIGRlc2Ny
aWJlX291dCBpcyBOb25lOgogICAgICAgIHJhaXNlIE5vdFRoaXNNZXRob2Qo
IidnaXQgZGVzY3JpYmUnIGZhaWxlZCIpCiAgICBkZXNjcmliZV9vdXQgPSBk
ZXNjcmliZV9vdXQuc3RyaXAoKQogICAgZnVsbF9vdXQsIHJjID0gcnVuX2Nv
bW1hbmQoR0lUUywgWyJyZXYtcGFyc2UiLCAiSEVBRCJdLCBjd2Q9cm9vdCkK
ICAgIGlmIGZ1bGxfb3V0IGlzIE5vbmU6CiAgICAgICAgcmFpc2UgTm90VGhp
c01ldGhvZCgiJ2dpdCByZXYtcGFyc2UnIGZhaWxlZCIpCiAgICBmdWxsX291
dCA9IGZ1bGxfb3V0LnN0cmlwKCkKCiAgICBwaWVjZXMgPSB7fQogICAgcGll
Y2VzWyJsb25nIl0gPSBmdWxsX291dAogICAgcGllY2VzWyJzaG9ydCJdID0g
ZnVsbF9vdXRbOjddICAjIG1heWJlIGltcHJvdmVkIGxhdGVyCiAgICBwaWVj
ZXNbImVycm9yIl0gPSBOb25lCgogICAgIyBwYXJzZSBkZXNjcmliZV9vdXQu
IEl0IHdpbGwgYmUgbGlrZSBUQUctTlVNLWdIRVhbLWRpcnR5XSBvciBIRVhb
LWRpcnR5XQogICAgIyBUQUcgbWlnaHQgaGF2ZSBoeXBoZW5zLgogICAgZ2l0
X2Rlc2NyaWJlID0gZGVzY3JpYmVfb3V0CgogICAgIyBsb29rIGZvciAtZGly
dHkgc3VmZml4CiAgICBkaXJ0eSA9IGdpdF9kZXNjcmliZS5lbmRzd2l0aCgi
LWRpcnR5IikKICAgIHBpZWNlc1siZGlydHkiXSA9IGRpcnR5CiAgICBpZiBk
aXJ0eToKICAgICAgICBnaXRfZGVzY3JpYmUgPSBnaXRfZGVzY3JpYmVbOmdp
dF9kZXNjcmliZS5yaW5kZXgoIi1kaXJ0eSIpXQoKICAgICMgbm93IHdlIGhh
dmUgVEFHLU5VTS1nSEVYIG9yIEhFWAoKICAgIGlmICItIiBpbiBnaXRfZGVz
Y3JpYmU6CiAgICAgICAgIyBUQUctTlVNLWdIRVgKICAgICAgICBtbyA9IHJl
LnNlYXJjaChyJ14oLispLShcZCspLWcoWzAtOWEtZl0rKSQnLCBnaXRfZGVz
Y3JpYmUpCiAgICAgICAgaWYgbm90IG1vOgogICAgICAgICAgICAjIHVucGFy
c2VhYmxlLiBNYXliZSBnaXQtZGVzY3JpYmUgaXMgbWlzYmVoYXZpbmc/CiAg
ICAgICAgICAgIHBpZWNlc1siZXJyb3IiXSA9ICgidW5hYmxlIHRvIHBhcnNl
IGdpdC1kZXNjcmliZSBvdXRwdXQ6ICclcyciCiAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAlIGRlc2NyaWJlX291dCkKICAgICAgICAgICAgcmV0
dXJuIHBpZWNlcwoKICAgICAgICAjIHRhZwogICAgICAgIGZ1bGxfdGFnID0g
bW8uZ3JvdXAoMSkKICAgICAgICBpZiBub3QgZnVsbF90YWcuc3RhcnRzd2l0
aCh0YWdfcHJlZml4KToKICAgICAgICAgICAgaWYgdmVyYm9zZToKICAgICAg
ICAgICAgICAgIGZtdCA9ICJ0YWcgJyVzJyBkb2Vzbid0IHN0YXJ0IHdpdGgg
cHJlZml4ICclcyciCiAgICAgICAgICAgICAgICBwcmludChmbXQgJSAoZnVs
bF90YWcsIHRhZ19wcmVmaXgpKQogICAgICAgICAgICBwaWVjZXNbImVycm9y
Il0gPSAoInRhZyAnJXMnIGRvZXNuJ3Qgc3RhcnQgd2l0aCBwcmVmaXggJyVz
JyIKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICUgKGZ1bGxfdGFn
LCB0YWdfcHJlZml4KSkKICAgICAgICAgICAgcmV0dXJuIHBpZWNlcwogICAg
ICAgIHBpZWNlc1siY2xvc2VzdC10YWciXSA9IGZ1bGxfdGFnW2xlbih0YWdf
cHJlZml4KTpdCgogICAgICAgICMgZGlzdGFuY2U6IG51bWJlciBvZiBjb21t
aXRzIHNpbmNlIHRhZwogICAgICAgIHBpZWNlc1siZGlzdGFuY2UiXSA9IGlu
dChtby5ncm91cCgyKSkKCiAgICAgICAgIyBjb21taXQ6IHNob3J0IGhleCBy
ZXZpc2lvbiBJRAogICAgICAgIHBpZWNlc1sic2hvcnQiXSA9IG1vLmdyb3Vw
KDMpCgogICAgZWxzZToKICAgICAgICAjIEhFWDogbm8gdGFncwogICAgICAg
IHBpZWNlc1siY2xvc2VzdC10YWciXSA9IE5vbmUKICAgICAgICBjb3VudF9v
dXQsIHJjID0gcnVuX2NvbW1hbmQoR0lUUywgWyJyZXYtbGlzdCIsICJIRUFE
IiwgIi0tY291bnQiXSwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgY3dkPXJvb3QpCiAgICAgICAgcGllY2VzWyJkaXN0YW5jZSJdID0g
aW50KGNvdW50X291dCkgICMgdG90YWwgbnVtYmVyIG9mIGNvbW1pdHMKCiAg
ICAjIGNvbW1pdCBkYXRlOiBzZWUgSVNPLTg2MDEgY29tbWVudCBpbiBnaXRf
dmVyc2lvbnNfZnJvbV9rZXl3b3JkcygpCiAgICBkYXRlID0gcnVuX2NvbW1h
bmQoR0lUUywgWyJzaG93IiwgIi1zIiwgIi0tZm9ybWF0PSVjaSIsICJIRUFE
Il0sCiAgICAgICAgICAgICAgICAgICAgICAgY3dkPXJvb3QpWzBdLnN0cmlw
KCkKICAgICMgVXNlIG9ubHkgdGhlIGxhc3QgbGluZS4gIFByZXZpb3VzIGxp
bmVzIG1heSBjb250YWluIEdQRyBzaWduYXR1cmUKICAgICMgaW5mb3JtYXRp
b24uCiAgICBkYXRlID0gZGF0ZS5zcGxpdGxpbmVzKClbLTFdCiAgICBwaWVj
ZXNbImRhdGUiXSA9IGRhdGUuc3RyaXAoKS5yZXBsYWNlKCIgIiwgIlQiLCAx
KS5yZXBsYWNlKCIgIiwgIiIsIDEpCgogICAgcmV0dXJuIHBpZWNlcwoKCmRl
ZiBkb192Y3NfaW5zdGFsbChtYW5pZmVzdF9pbiwgdmVyc2lvbmZpbGVfc291
cmNlLCBpcHkpOgogICAgIiIiR2l0LXNwZWNpZmljIGluc3RhbGxhdGlvbiBs
b2dpYyBmb3IgVmVyc2lvbmVlci4KCiAgICBGb3IgR2l0LCB0aGlzIG1lYW5z
IGNyZWF0aW5nL2NoYW5naW5nIC5naXRhdHRyaWJ1dGVzIHRvIG1hcmsgX3Zl
cnNpb24ucHkKICAgIGZvciBleHBvcnQtc3Vic3Qga2V5d29yZCBzdWJzdGl0
dXRpb24uCiAgICAiIiIKICAgIEdJVFMgPSBbImdpdCJdCiAgICBpZiBzeXMu
cGxhdGZvcm0gPT0gIndpbjMyIjoKICAgICAgICBHSVRTID0gWyJnaXQuY21k
IiwgImdpdC5leGUiXQogICAgZmlsZXMgPSBbbWFuaWZlc3RfaW4sIHZlcnNp
b25maWxlX3NvdXJjZV0KICAgIGlmIGlweToKICAgICAgICBmaWxlcy5hcHBl
bmQoaXB5KQogICAgdHJ5OgogICAgICAgIG1lID0gX19maWxlX18KICAgICAg
ICBpZiBtZS5lbmRzd2l0aCgiLnB5YyIpIG9yIG1lLmVuZHN3aXRoKCIucHlv
Iik6CiAgICAgICAgICAgIG1lID0gb3MucGF0aC5zcGxpdGV4dChtZSlbMF0g
KyAiLnB5IgogICAgICAgIHZlcnNpb25lZXJfZmlsZSA9IG9zLnBhdGgucmVs
cGF0aChtZSkKICAgIGV4Y2VwdCBOYW1lRXJyb3I6CiAgICAgICAgdmVyc2lv
bmVlcl9maWxlID0gInZlcnNpb25lZXIucHkiCiAgICBmaWxlcy5hcHBlbmQo
dmVyc2lvbmVlcl9maWxlKQogICAgcHJlc2VudCA9IEZhbHNlCiAgICB0cnk6
CiAgICAgICAgZiA9IG9wZW4oIi5naXRhdHRyaWJ1dGVzIiwgInIiKQogICAg
ICAgIGZvciBsaW5lIGluIGYucmVhZGxpbmVzKCk6CiAgICAgICAgICAgIGlm
IGxpbmUuc3RyaXAoKS5zdGFydHN3aXRoKHZlcnNpb25maWxlX3NvdXJjZSk6
CiAgICAgICAgICAgICAgICBpZiAiZXhwb3J0LXN1YnN0IiBpbiBsaW5lLnN0
cmlwKCkuc3BsaXQoKVsxOl06CiAgICAgICAgICAgICAgICAgICAgcHJlc2Vu
dCA9IFRydWUKICAgICAgICBmLmNsb3NlKCkKICAgIGV4Y2VwdCBFbnZpcm9u
bWVudEVycm9yOgogICAgICAgIHBhc3MKICAgIGlmIG5vdCBwcmVzZW50Ogog
ICAgICAgIGYgPSBvcGVuKCIuZ2l0YXR0cmlidXRlcyIsICJhKyIpCiAgICAg
ICAgZi53cml0ZSgiJXMgZXhwb3J0LXN1YnN0XG4iICUgdmVyc2lvbmZpbGVf
c291cmNlKQogICAgICAgIGYuY2xvc2UoKQogICAgICAgIGZpbGVzLmFwcGVu
ZCgiLmdpdGF0dHJpYnV0ZXMiKQogICAgcnVuX2NvbW1hbmQoR0lUUywgWyJh
ZGQiLCAiLS0iXSArIGZpbGVzKQoKCmRlZiB2ZXJzaW9uc19mcm9tX3BhcmVu
dGRpcihwYXJlbnRkaXJfcHJlZml4LCByb290LCB2ZXJib3NlKToKICAgICIi
IlRyeSB0byBkZXRlcm1pbmUgdGhlIHZlcnNpb24gZnJvbSB0aGUgcGFyZW50
IGRpcmVjdG9yeSBuYW1lLgoKICAgIFNvdXJjZSB0YXJiYWxscyBjb252ZW50
aW9uYWxseSB1bnBhY2sgaW50byBhIGRpcmVjdG9yeSB0aGF0IGluY2x1ZGVz
IGJvdGgKICAgIHRoZSBwcm9qZWN0IG5hbWUgYW5kIGEgdmVyc2lvbiBzdHJp
bmcuIFdlIHdpbGwgYWxzbyBzdXBwb3J0IHNlYXJjaGluZyB1cAogICAgdHdv
IGRpcmVjdG9yeSBsZXZlbHMgZm9yIGFuIGFwcHJvcHJpYXRlbHkgbmFtZWQg
cGFyZW50IGRpcmVjdG9yeQogICAgIiIiCiAgICByb290ZGlycyA9IFtdCgog
ICAgZm9yIGkgaW4gcmFuZ2UoMyk6CiAgICAgICAgZGlybmFtZSA9IG9zLnBh
dGguYmFzZW5hbWUocm9vdCkKICAgICAgICBpZiBkaXJuYW1lLnN0YXJ0c3dp
dGgocGFyZW50ZGlyX3ByZWZpeCk6CiAgICAgICAgICAgIHJldHVybiB7InZl
cnNpb24iOiBkaXJuYW1lW2xlbihwYXJlbnRkaXJfcHJlZml4KTpdLAogICAg
ICAgICAgICAgICAgICAgICJmdWxsLXJldmlzaW9uaWQiOiBOb25lLAogICAg
ICAgICAgICAgICAgICAgICJkaXJ0eSI6IEZhbHNlLCAiZXJyb3IiOiBOb25l
LCAiZGF0ZSI6IE5vbmV9CiAgICAgICAgZWxzZToKICAgICAgICAgICAgcm9v
dGRpcnMuYXBwZW5kKHJvb3QpCiAgICAgICAgICAgIHJvb3QgPSBvcy5wYXRo
LmRpcm5hbWUocm9vdCkgICMgdXAgYSBsZXZlbAoKICAgIGlmIHZlcmJvc2U6
CiAgICAgICAgcHJpbnQoIlRyaWVkIGRpcmVjdG9yaWVzICVzIGJ1dCBub25l
IHN0YXJ0ZWQgd2l0aCBwcmVmaXggJXMiICUKICAgICAgICAgICAgICAoc3Ry
KHJvb3RkaXJzKSwgcGFyZW50ZGlyX3ByZWZpeCkpCiAgICByYWlzZSBOb3RU
aGlzTWV0aG9kKCJyb290ZGlyIGRvZXNuJ3Qgc3RhcnQgd2l0aCBwYXJlbnRk
aXJfcHJlZml4IikKCgpTSE9SVF9WRVJTSU9OX1BZID0gIiIiCiMgVGhpcyBm
aWxlIHdhcyBnZW5lcmF0ZWQgYnkgJ3ZlcnNpb25lZXIucHknICgwLjE5KSBm
cm9tCiMgcmV2aXNpb24tY29udHJvbCBzeXN0ZW0gZGF0YSwgb3IgZnJvbSB0
aGUgcGFyZW50IGRpcmVjdG9yeSBuYW1lIG9mIGFuCiMgdW5wYWNrZWQgc291
cmNlIGFyY2hpdmUuIERpc3RyaWJ1dGlvbiB0YXJiYWxscyBjb250YWluIGEg
cHJlLWdlbmVyYXRlZCBjb3B5CiMgb2YgdGhpcyBmaWxlLgoKaW1wb3J0IGpz
b24KCnZlcnNpb25fanNvbiA9ICcnJwolcwonJycgICMgRU5EIFZFUlNJT05f
SlNPTgoKCmRlZiBnZXRfdmVyc2lvbnMoKToKICAgIHJldHVybiBqc29uLmxv
YWRzKHZlcnNpb25fanNvbikKIiIiCgoKZGVmIHZlcnNpb25zX2Zyb21fZmls
ZShmaWxlbmFtZSk6CiAgICAiIiJUcnkgdG8gZGV0ZXJtaW5lIHRoZSB2ZXJz
aW9uIGZyb20gX3ZlcnNpb24ucHkgaWYgcHJlc2VudC4iIiIKICAgIHRyeToK
ICAgICAgICB3aXRoIG9wZW4oZmlsZW5hbWUpIGFzIGY6CiAgICAgICAgICAg
IGNvbnRlbnRzID0gZi5yZWFkKCkKICAgIGV4Y2VwdCBFbnZpcm9ubWVudEVy
cm9yOgogICAgICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoInVuYWJsZSB0byBy
ZWFkIF92ZXJzaW9uLnB5IikKICAgIG1vID0gcmUuc2VhcmNoKHIidmVyc2lv
bl9qc29uID0gJycnXG4oLiopJycnICAjIEVORCBWRVJTSU9OX0pTT04iLAog
ICAgICAgICAgICAgICAgICAgY29udGVudHMsIHJlLk0gfCByZS5TKQogICAg
aWYgbm90IG1vOgogICAgICAgIG1vID0gcmUuc2VhcmNoKHIidmVyc2lvbl9q
c29uID0gJycnXHJcbiguKiknJycgICMgRU5EIFZFUlNJT05fSlNPTiIsCiAg
ICAgICAgICAgICAgICAgICAgICAgY29udGVudHMsIHJlLk0gfCByZS5TKQog
ICAgaWYgbm90IG1vOgogICAgICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoIm5v
IHZlcnNpb25fanNvbiBpbiBfdmVyc2lvbi5weSIpCiAgICByZXR1cm4ganNv
bi5sb2Fkcyhtby5ncm91cCgxKSkKCgpkZWYgd3JpdGVfdG9fdmVyc2lvbl9m
aWxlKGZpbGVuYW1lLCB2ZXJzaW9ucyk6CiAgICAiIiJXcml0ZSB0aGUgZ2l2
ZW4gdmVyc2lvbiBudW1iZXIgdG8gdGhlIGdpdmVuIF92ZXJzaW9uLnB5IGZp
bGUuIiIiCiAgICBvcy51bmxpbmsoZmlsZW5hbWUpCiAgICBjb250ZW50cyA9
IGpzb24uZHVtcHModmVyc2lvbnMsIHNvcnRfa2V5cz1UcnVlLAogICAgICAg
ICAgICAgICAgICAgICAgICAgIGluZGVudD0xLCBzZXBhcmF0b3JzPSgiLCIs
ICI6ICIpKQogICAgd2l0aCBvcGVuKGZpbGVuYW1lLCAidyIpIGFzIGY6CiAg
ICAgICAgZi53cml0ZShTSE9SVF9WRVJTSU9OX1BZICUgY29udGVudHMpCgog
ICAgcHJpbnQoInNldCAlcyB0byAnJXMnIiAlIChmaWxlbmFtZSwgdmVyc2lv
bnNbInZlcnNpb24iXSkpCgoKZGVmIHBsdXNfb3JfZG90KHBpZWNlcyk6CiAg
ICAiIiJSZXR1cm4gYSArIGlmIHdlIGRvbid0IGFscmVhZHkgaGF2ZSBvbmUs
IGVsc2UgcmV0dXJuIGEgLiIiIgogICAgaWYgIisiIGluIHBpZWNlcy5nZXQo
ImNsb3Nlc3QtdGFnIiwgIiIpOgogICAgICAgIHJldHVybiAiLiIKICAgIHJl
dHVybiAiKyIKCgpkZWYgcmVuZGVyX3BlcDQ0MChwaWVjZXMpOgogICAgIiIi
QnVpbGQgdXAgdmVyc2lvbiBzdHJpbmcsIHdpdGggcG9zdC1yZWxlYXNlICJs
b2NhbCB2ZXJzaW9uIGlkZW50aWZpZXIiLgoKICAgIE91ciBnb2FsOiBUQUdb
K0RJU1RBTkNFLmdIRVhbLmRpcnR5XV0gLiBOb3RlIHRoYXQgaWYgeW91CiAg
ICBnZXQgYSB0YWdnZWQgYnVpbGQgYW5kIHRoZW4gZGlydHkgaXQsIHlvdSds
bCBnZXQgVEFHKzAuZ0hFWC5kaXJ0eQoKICAgIEV4Y2VwdGlvbnM6CiAgICAx
OiBubyB0YWdzLiBnaXRfZGVzY3JpYmUgd2FzIGp1c3QgSEVYLiAwK3VudGFn
Z2VkLkRJU1RBTkNFLmdIRVhbLmRpcnR5XQogICAgIiIiCiAgICBpZiBwaWVj
ZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNb
ImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl0g
b3IgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCArPSBw
bHVzX29yX2RvdChwaWVjZXMpCiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIl
ZC5nJXMiICUgKHBpZWNlc1siZGlzdGFuY2UiXSwgcGllY2VzWyJzaG9ydCJd
KQogICAgICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAg
ICAgICByZW5kZXJlZCArPSAiLmRpcnR5IgogICAgZWxzZToKICAgICAgICAj
IGV4Y2VwdGlvbiAjMQogICAgICAgIHJlbmRlcmVkID0gIjArdW50YWdnZWQu
JWQuZyVzIiAlIChwaWVjZXNbImRpc3RhbmNlIl0sCiAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgIHBpZWNlc1sic2hvcnQiXSkK
ICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAgIHJlbmRl
cmVkICs9ICIuZGlydHkiCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVu
ZGVyX3BlcDQ0MF9wcmUocGllY2VzKToKICAgICIiIlRBR1sucG9zdDAuZGV2
RElTVEFOQ0VdIC0tIE5vIC1kaXJ0eS4KCiAgICBFeGNlcHRpb25zOgogICAg
MTogbm8gdGFncy4gMC5wb3N0MC5kZXZESVNUQU5DRQogICAgIiIiCiAgICBp
ZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBw
aWVjZXNbImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3Rh
bmNlIl06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIucG9zdDAuZGV2JWQi
ICUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICBlbHNlOgogICAgICAgICMgZXhj
ZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSAiMC5wb3N0MC5kZXYlZCIg
JSBwaWVjZXNbImRpc3RhbmNlIl0KICAgIHJldHVybiByZW5kZXJlZAoKCmRl
ZiByZW5kZXJfcGVwNDQwX3Bvc3QocGllY2VzKToKICAgICIiIlRBR1sucG9z
dERJU1RBTkNFWy5kZXYwXStnSEVYXSAuCgogICAgVGhlICIuZGV2MCIgbWVh
bnMgZGlydHkuIE5vdGUgdGhhdCAuZGV2MCBzb3J0cyBiYWNrd2FyZHMKICAg
IChhIGRpcnR5IHRyZWUgd2lsbCBhcHBlYXIgIm9sZGVyIiB0aGFuIHRoZSBj
b3JyZXNwb25kaW5nIGNsZWFuIG9uZSksCiAgICBidXQgeW91IHNob3VsZG4n
dCBiZSByZWxlYXNpbmcgc29mdHdhcmUgd2l0aCAtZGlydHkgYW55d2F5cy4K
CiAgICBFeGNlcHRpb25zOgogICAgMTogbm8gdGFncy4gMC5wb3N0RElTVEFO
Q0VbLmRldjBdCiAgICAiIiIKICAgIGlmIHBpZWNlc1siY2xvc2VzdC10YWci
XToKICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10YWciXQog
ICAgICAgIGlmIHBpZWNlc1siZGlzdGFuY2UiXSBvciBwaWVjZXNbImRpcnR5
Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIucG9zdCVkIiAlIHBpZWNl
c1siZGlzdGFuY2UiXQogICAgICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06
CiAgICAgICAgICAgICAgICByZW5kZXJlZCArPSAiLmRldjAiCiAgICAgICAg
ICAgIHJlbmRlcmVkICs9IHBsdXNfb3JfZG90KHBpZWNlcykKICAgICAgICAg
ICAgcmVuZGVyZWQgKz0gImclcyIgJSBwaWVjZXNbInNob3J0Il0KICAgIGVs
c2U6CiAgICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9
ICIwLnBvc3QlZCIgJSBwaWVjZXNbImRpc3RhbmNlIl0KICAgICAgICBpZiBw
aWVjZXNbImRpcnR5Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIuZGV2
MCIKICAgICAgICByZW5kZXJlZCArPSAiK2clcyIgJSBwaWVjZXNbInNob3J0
Il0KICAgIHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJfcGVwNDQwX29s
ZChwaWVjZXMpOgogICAgIiIiVEFHWy5wb3N0RElTVEFOQ0VbLmRldjBdXSAu
CgogICAgVGhlICIuZGV2MCIgbWVhbnMgZGlydHkuCgogICAgRXhjZXB0aW9u
czoKICAgIDE6IG5vIHRhZ3MuIDAucG9zdERJU1RBTkNFWy5kZXYwXQogICAg
IiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVu
ZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVj
ZXNbImRpc3RhbmNlIl0gb3IgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAg
ICByZW5kZXJlZCArPSAiLnBvc3QlZCIgJSBwaWVjZXNbImRpc3RhbmNlIl0K
ICAgICAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICAg
ICAgcmVuZGVyZWQgKz0gIi5kZXYwIgogICAgZWxzZToKICAgICAgICAjIGV4
Y2VwdGlvbiAjMQogICAgICAgIHJlbmRlcmVkID0gIjAucG9zdCVkIiAlIHBp
ZWNlc1siZGlzdGFuY2UiXQogICAgICAgIGlmIHBpZWNlc1siZGlydHkiXToK
ICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kZXYwIgogICAgcmV0dXJuIHJl
bmRlcmVkCgoKZGVmIHJlbmRlcl9naXRfZGVzY3JpYmUocGllY2VzKToKICAg
ICIiIlRBR1stRElTVEFOQ0UtZ0hFWF1bLWRpcnR5XS4KCiAgICBMaWtlICdn
aXQgZGVzY3JpYmUgLS10YWdzIC0tZGlydHkgLS1hbHdheXMnLgoKICAgIEV4
Y2VwdGlvbnM6CiAgICAxOiBubyB0YWdzLiBIRVhbLWRpcnR5XSAgKG5vdGU6
IG5vICdnJyBwcmVmaXgpCiAgICAiIiIKICAgIGlmIHBpZWNlc1siY2xvc2Vz
dC10YWciXToKICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10
YWciXQogICAgICAgIGlmIHBpZWNlc1siZGlzdGFuY2UiXToKICAgICAgICAg
ICAgcmVuZGVyZWQgKz0gIi0lZC1nJXMiICUgKHBpZWNlc1siZGlzdGFuY2Ui
XSwgcGllY2VzWyJzaG9ydCJdKQogICAgZWxzZToKICAgICAgICAjIGV4Y2Vw
dGlvbiAjMQogICAgICAgIHJlbmRlcmVkID0gcGllY2VzWyJzaG9ydCJdCiAg
ICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgcmVuZGVyZWQgKz0gIi1k
aXJ0eSIKICAgIHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJfZ2l0X2Rl
c2NyaWJlX2xvbmcocGllY2VzKToKICAgICIiIlRBRy1ESVNUQU5DRS1nSEVY
Wy1kaXJ0eV0uCgogICAgTGlrZSAnZ2l0IGRlc2NyaWJlIC0tdGFncyAtLWRp
cnR5IC0tYWx3YXlzIC1sb25nJy4KICAgIFRoZSBkaXN0YW5jZS9oYXNoIGlz
IHVuY29uZGl0aW9uYWwuCgogICAgRXhjZXB0aW9uczoKICAgIDE6IG5vIHRh
Z3MuIEhFWFstZGlydHldICAobm90ZTogbm8gJ2cnIHByZWZpeCkKICAgICIi
IgogICAgaWYgcGllY2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRl
cmVkID0gcGllY2VzWyJjbG9zZXN0LXRhZyJdCiAgICAgICAgcmVuZGVyZWQg
Kz0gIi0lZC1nJXMiICUgKHBpZWNlc1siZGlzdGFuY2UiXSwgcGllY2VzWyJz
aG9ydCJdKQogICAgZWxzZToKICAgICAgICAjIGV4Y2VwdGlvbiAjMQogICAg
ICAgIHJlbmRlcmVkID0gcGllY2VzWyJzaG9ydCJdCiAgICBpZiBwaWVjZXNb
ImRpcnR5Il06CiAgICAgICAgcmVuZGVyZWQgKz0gIi1kaXJ0eSIKICAgIHJl
dHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXIocGllY2VzLCBzdHlsZSk6CiAg
ICAiIiJSZW5kZXIgdGhlIGdpdmVuIHZlcnNpb24gcGllY2VzIGludG8gdGhl
IHJlcXVlc3RlZCBzdHlsZS4iIiIKICAgIGlmIHBpZWNlc1siZXJyb3IiXToK
ICAgICAgICByZXR1cm4geyJ2ZXJzaW9uIjogInVua25vd24iLAogICAgICAg
ICAgICAgICAgImZ1bGwtcmV2aXNpb25pZCI6IHBpZWNlcy5nZXQoImxvbmci
KSwKICAgICAgICAgICAgICAgICJkaXJ0eSI6IE5vbmUsCiAgICAgICAgICAg
ICAgICAiZXJyb3IiOiBwaWVjZXNbImVycm9yIl0sCiAgICAgICAgICAgICAg
ICAiZGF0ZSI6IE5vbmV9CgogICAgaWYgbm90IHN0eWxlIG9yIHN0eWxlID09
ICJkZWZhdWx0IjoKICAgICAgICBzdHlsZSA9ICJwZXA0NDAiICAjIHRoZSBk
ZWZhdWx0CgogICAgaWYgc3R5bGUgPT0gInBlcDQ0MCI6CiAgICAgICAgcmVu
ZGVyZWQgPSByZW5kZXJfcGVwNDQwKHBpZWNlcykKICAgIGVsaWYgc3R5bGUg
PT0gInBlcDQ0MC1wcmUiOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3Bl
cDQ0MF9wcmUocGllY2VzKQogICAgZWxpZiBzdHlsZSA9PSAicGVwNDQwLXBv
c3QiOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MF9wb3N0KHBp
ZWNlcykKICAgIGVsaWYgc3R5bGUgPT0gInBlcDQ0MC1vbGQiOgogICAgICAg
IHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MF9vbGQocGllY2VzKQogICAgZWxp
ZiBzdHlsZSA9PSAiZ2l0LWRlc2NyaWJlIjoKICAgICAgICByZW5kZXJlZCA9
IHJlbmRlcl9naXRfZGVzY3JpYmUocGllY2VzKQogICAgZWxpZiBzdHlsZSA9
PSAiZ2l0LWRlc2NyaWJlLWxvbmciOgogICAgICAgIHJlbmRlcmVkID0gcmVu
ZGVyX2dpdF9kZXNjcmliZV9sb25nKHBpZWNlcykKICAgIGVsc2U6CiAgICAg
ICAgcmFpc2UgVmFsdWVFcnJvcigidW5rbm93biBzdHlsZSAnJXMnIiAlIHN0
eWxlKQoKICAgIHJldHVybiB7InZlcnNpb24iOiByZW5kZXJlZCwgImZ1bGwt
cmV2aXNpb25pZCI6IHBpZWNlc1sibG9uZyJdLAogICAgICAgICAgICAiZGly
dHkiOiBwaWVjZXNbImRpcnR5Il0sICJlcnJvciI6IE5vbmUsCiAgICAgICAg
ICAgICJkYXRlIjogcGllY2VzLmdldCgiZGF0ZSIpfQoKCmNsYXNzIFZlcnNp
b25lZXJCYWRSb290RXJyb3IoRXhjZXB0aW9uKToKICAgICIiIlRoZSBwcm9q
ZWN0IHJvb3QgZGlyZWN0b3J5IGlzIHVua25vd24gb3IgbWlzc2luZyBrZXkg
ZmlsZXMuIiIiCgoKZGVmIGdldF92ZXJzaW9ucyh2ZXJib3NlPUZhbHNlKToK
ICAgICIiIkdldCB0aGUgcHJvamVjdCB2ZXJzaW9uIGZyb20gd2hhdGV2ZXIg
c291cmNlIGlzIGF2YWlsYWJsZS4KCiAgICBSZXR1cm5zIGRpY3Qgd2l0aCB0
d28ga2V5czogJ3ZlcnNpb24nIGFuZCAnZnVsbCcuCiAgICAiIiIKICAgIGlm
ICJ2ZXJzaW9uZWVyIiBpbiBzeXMubW9kdWxlczoKICAgICAgICAjIHNlZSB0
aGUgZGlzY3Vzc2lvbiBpbiBjbWRjbGFzcy5weTpnZXRfY21kY2xhc3MoKQog
ICAgICAgIGRlbCBzeXMubW9kdWxlc1sidmVyc2lvbmVlciJdCgogICAgcm9v
dCA9IGdldF9yb290KCkKICAgIGNmZyA9IGdldF9jb25maWdfZnJvbV9yb290
KHJvb3QpCgogICAgYXNzZXJ0IGNmZy5WQ1MgaXMgbm90IE5vbmUsICJwbGVh
c2Ugc2V0IFt2ZXJzaW9uZWVyXVZDUz0gaW4gc2V0dXAuY2ZnIgogICAgaGFu
ZGxlcnMgPSBIQU5ETEVSUy5nZXQoY2ZnLlZDUykKICAgIGFzc2VydCBoYW5k
bGVycywgInVucmVjb2duaXplZCBWQ1MgJyVzJyIgJSBjZmcuVkNTCiAgICB2
ZXJib3NlID0gdmVyYm9zZSBvciBjZmcudmVyYm9zZQogICAgYXNzZXJ0IGNm
Zy52ZXJzaW9uZmlsZV9zb3VyY2UgaXMgbm90IE5vbmUsIFwKICAgICAgICAi
cGxlYXNlIHNldCB2ZXJzaW9uZWVyLnZlcnNpb25maWxlX3NvdXJjZSIKICAg
IGFzc2VydCBjZmcudGFnX3ByZWZpeCBpcyBub3QgTm9uZSwgInBsZWFzZSBz
ZXQgdmVyc2lvbmVlci50YWdfcHJlZml4IgoKICAgIHZlcnNpb25maWxlX2Fi
cyA9IG9zLnBhdGguam9pbihyb290LCBjZmcudmVyc2lvbmZpbGVfc291cmNl
KQoKICAgICMgZXh0cmFjdCB2ZXJzaW9uIGZyb20gZmlyc3Qgb2Y6IF92ZXJz
aW9uLnB5LCBWQ1MgY29tbWFuZCAoZS5nLiAnZ2l0CiAgICAjIGRlc2NyaWJl
JyksIHBhcmVudGRpci4gVGhpcyBpcyBtZWFudCB0byB3b3JrIGZvciBkZXZl
bG9wZXJzIHVzaW5nIGEKICAgICMgc291cmNlIGNoZWNrb3V0LCBmb3IgdXNl
cnMgb2YgYSB0YXJiYWxsIGNyZWF0ZWQgYnkgJ3NldHVwLnB5IHNkaXN0JywK
ICAgICMgYW5kIGZvciB1c2VycyBvZiBhIHRhcmJhbGwvemlwYmFsbCBjcmVh
dGVkIGJ5ICdnaXQgYXJjaGl2ZScgb3IgZ2l0aHViJ3MKICAgICMgZG93bmxv
YWQtZnJvbS10YWcgZmVhdHVyZSBvciB0aGUgZXF1aXZhbGVudCBpbiBvdGhl
ciBWQ1Nlcy4KCiAgICBnZXRfa2V5d29yZHNfZiA9IGhhbmRsZXJzLmdldCgi
Z2V0X2tleXdvcmRzIikKICAgIGZyb21fa2V5d29yZHNfZiA9IGhhbmRsZXJz
LmdldCgia2V5d29yZHMiKQogICAgaWYgZ2V0X2tleXdvcmRzX2YgYW5kIGZy
b21fa2V5d29yZHNfZjoKICAgICAgICB0cnk6CiAgICAgICAgICAgIGtleXdv
cmRzID0gZ2V0X2tleXdvcmRzX2YodmVyc2lvbmZpbGVfYWJzKQogICAgICAg
ICAgICB2ZXIgPSBmcm9tX2tleXdvcmRzX2Yoa2V5d29yZHMsIGNmZy50YWdf
cHJlZml4LCB2ZXJib3NlKQogICAgICAgICAgICBpZiB2ZXJib3NlOgogICAg
ICAgICAgICAgICAgcHJpbnQoImdvdCB2ZXJzaW9uIGZyb20gZXhwYW5kZWQg
a2V5d29yZCAlcyIgJSB2ZXIpCiAgICAgICAgICAgIHJldHVybiB2ZXIKICAg
ICAgICBleGNlcHQgTm90VGhpc01ldGhvZDoKICAgICAgICAgICAgcGFzcwoK
ICAgIHRyeToKICAgICAgICB2ZXIgPSB2ZXJzaW9uc19mcm9tX2ZpbGUodmVy
c2lvbmZpbGVfYWJzKQogICAgICAgIGlmIHZlcmJvc2U6CiAgICAgICAgICAg
IHByaW50KCJnb3QgdmVyc2lvbiBmcm9tIGZpbGUgJXMgJXMiICUgKHZlcnNp
b25maWxlX2FicywgdmVyKSkKICAgICAgICByZXR1cm4gdmVyCiAgICBleGNl
cHQgTm90VGhpc01ldGhvZDoKICAgICAgICBwYXNzCgogICAgZnJvbV92Y3Nf
ZiA9IGhhbmRsZXJzLmdldCgicGllY2VzX2Zyb21fdmNzIikKICAgIGlmIGZy
b21fdmNzX2Y6CiAgICAgICAgdHJ5OgogICAgICAgICAgICBwaWVjZXMgPSBm
cm9tX3Zjc19mKGNmZy50YWdfcHJlZml4LCByb290LCB2ZXJib3NlKQogICAg
ICAgICAgICB2ZXIgPSByZW5kZXIocGllY2VzLCBjZmcuc3R5bGUpCiAgICAg
ICAgICAgIGlmIHZlcmJvc2U6CiAgICAgICAgICAgICAgICBwcmludCgiZ290
IHZlcnNpb24gZnJvbSBWQ1MgJXMiICUgdmVyKQogICAgICAgICAgICByZXR1
cm4gdmVyCiAgICAgICAgZXhjZXB0IE5vdFRoaXNNZXRob2Q6CiAgICAgICAg
ICAgIHBhc3MKCiAgICB0cnk6CiAgICAgICAgaWYgY2ZnLnBhcmVudGRpcl9w
cmVmaXg6CiAgICAgICAgICAgIHZlciA9IHZlcnNpb25zX2Zyb21fcGFyZW50
ZGlyKGNmZy5wYXJlbnRkaXJfcHJlZml4LCByb290LCB2ZXJib3NlKQogICAg
ICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICAgICAgcHJpbnQoImdv
dCB2ZXJzaW9uIGZyb20gcGFyZW50ZGlyICVzIiAlIHZlcikKICAgICAgICAg
ICAgcmV0dXJuIHZlcgogICAgZXhjZXB0IE5vdFRoaXNNZXRob2Q6CiAgICAg
ICAgcGFzcwoKICAgIGlmIHZlcmJvc2U6CiAgICAgICAgcHJpbnQoInVuYWJs
ZSB0byBjb21wdXRlIHZlcnNpb24iKQoKICAgIHJldHVybiB7InZlcnNpb24i
OiAiMCt1bmtub3duIiwgImZ1bGwtcmV2aXNpb25pZCI6IE5vbmUsCiAgICAg
ICAgICAgICJkaXJ0eSI6IE5vbmUsICJlcnJvciI6ICJ1bmFibGUgdG8gY29t
cHV0ZSB2ZXJzaW9uIiwKICAgICAgICAgICAgImRhdGUiOiBOb25lfQoKCmRl
ZiBnZXRfdmVyc2lvbigpOgogICAgIiIiR2V0IHRoZSBzaG9ydCB2ZXJzaW9u
IHN0cmluZyBmb3IgdGhpcyBwcm9qZWN0LiIiIgogICAgcmV0dXJuIGdldF92
ZXJzaW9ucygpWyJ2ZXJzaW9uIl0KCgpkZWYgZ2V0X2NtZGNsYXNzKGNtZGNs
YXNzPU5vbmUpOgogICAgIiIiR2V0IHRoZSBjdXN0b20gc2V0dXB0b29scy9k
aXN0dXRpbHMgc3ViY2xhc3NlcyB1c2VkIGJ5IFZlcnNpb25lZXIuCgogICAg
SWYgdGhlIHBhY2thZ2UgdXNlcyBhIGRpZmZlcmVudCBjbWRjbGFzcyAoZS5n
LiBvbmUgZnJvbSBudW1weSksIGl0CiAgICBzaG91bGQgYmUgcHJvdmlkZSBh
cyBhbiBhcmd1bWVudC4KICAgICIiIgogICAgaWYgInZlcnNpb25lZXIiIGlu
IHN5cy5tb2R1bGVzOgogICAgICAgIGRlbCBzeXMubW9kdWxlc1sidmVyc2lv
bmVlciJdCiAgICAgICAgIyB0aGlzIGZpeGVzIHRoZSAicHl0aG9uIHNldHVw
LnB5IGRldmVsb3AiIGNhc2UgKGFsc28gJ2luc3RhbGwnIGFuZAogICAgICAg
ICMgJ2Vhc3lfaW5zdGFsbCAuJyksIGluIHdoaWNoIHN1YmRlcGVuZGVuY2ll
cyBvZiB0aGUgbWFpbiBwcm9qZWN0IGFyZQogICAgICAgICMgYnVpbHQgKHVz
aW5nIHNldHVwLnB5IGJkaXN0X2VnZykgaW4gdGhlIHNhbWUgcHl0aG9uIHBy
b2Nlc3MuIEFzc3VtZQogICAgICAgICMgYSBtYWluIHByb2plY3QgQSBhbmQg
YSBkZXBlbmRlbmN5IEIsIHdoaWNoIHVzZSBkaWZmZXJlbnQgdmVyc2lvbnMK
ICAgICAgICAjIG9mIFZlcnNpb25lZXIuIEEncyBzZXR1cC5weSBpbXBvcnRz
IEEncyBWZXJzaW9uZWVyLCBsZWF2aW5nIGl0IGluCiAgICAgICAgIyBzeXMu
bW9kdWxlcyBieSB0aGUgdGltZSBCJ3Mgc2V0dXAucHkgaXMgZXhlY3V0ZWQs
IGNhdXNpbmcgQiB0byBydW4KICAgICAgICAjIHdpdGggdGhlIHdyb25nIHZl
cnNpb25lZXIuIFNldHVwdG9vbHMgd3JhcHMgdGhlIHN1Yi1kZXAgYnVpbGRz
IGluIGEKICAgICAgICAjIHNhbmRib3ggdGhhdCByZXN0b3JlcyBzeXMubW9k
dWxlcyB0byBpdCdzIHByZS1idWlsZCBzdGF0ZSwgc28gdGhlCiAgICAgICAg
IyBwYXJlbnQgaXMgcHJvdGVjdGVkIGFnYWluc3QgdGhlIGNoaWxkJ3MgImlt
cG9ydCB2ZXJzaW9uZWVyIi4gQnkKICAgICAgICAjIHJlbW92aW5nIG91cnNl
bHZlcyBmcm9tIHN5cy5tb2R1bGVzIGhlcmUsIGJlZm9yZSB0aGUgY2hpbGQg
YnVpbGQKICAgICAgICAjIGhhcHBlbnMsIHdlIHByb3RlY3QgdGhlIGNoaWxk
IGZyb20gdGhlIHBhcmVudCdzIHZlcnNpb25lZXIgdG9vLgogICAgICAgICMg
QWxzbyBzZWUgaHR0cHM6Ly9naXRodWIuY29tL3B5dGhvbi12ZXJzaW9uZWVy
L3B5dGhvbi12ZXJzaW9uZWVyL2lzc3Vlcy81MgoKICAgIGNtZHMgPSB7fSBp
ZiBjbWRjbGFzcyBpcyBOb25lIGVsc2UgY21kY2xhc3MuY29weSgpCgogICAg
IyB3ZSBhZGQgInZlcnNpb24iIHRvIGJvdGggZGlzdHV0aWxzIGFuZCBzZXR1
cHRvb2xzCiAgICBmcm9tIGRpc3R1dGlscy5jb3JlIGltcG9ydCBDb21tYW5k
CgogICAgY2xhc3MgY21kX3ZlcnNpb24oQ29tbWFuZCk6CiAgICAgICAgZGVz
Y3JpcHRpb24gPSAicmVwb3J0IGdlbmVyYXRlZCB2ZXJzaW9uIHN0cmluZyIK
ICAgICAgICB1c2VyX29wdGlvbnMgPSBbXQogICAgICAgIGJvb2xlYW5fb3B0
aW9ucyA9IFtdCgogICAgICAgIGRlZiBpbml0aWFsaXplX29wdGlvbnMoc2Vs
Zik6CiAgICAgICAgICAgIHBhc3MKCiAgICAgICAgZGVmIGZpbmFsaXplX29w
dGlvbnMoc2VsZik6CiAgICAgICAgICAgIHBhc3MKCiAgICAgICAgZGVmIHJ1
bihzZWxmKToKICAgICAgICAgICAgdmVycyA9IGdldF92ZXJzaW9ucyh2ZXJi
b3NlPVRydWUpCiAgICAgICAgICAgIHByaW50KCJWZXJzaW9uOiAlcyIgJSB2
ZXJzWyJ2ZXJzaW9uIl0pCiAgICAgICAgICAgIHByaW50KCIgZnVsbC1yZXZp
c2lvbmlkOiAlcyIgJSB2ZXJzLmdldCgiZnVsbC1yZXZpc2lvbmlkIikpCiAg
ICAgICAgICAgIHByaW50KCIgZGlydHk6ICVzIiAlIHZlcnMuZ2V0KCJkaXJ0
eSIpKQogICAgICAgICAgICBwcmludCgiIGRhdGU6ICVzIiAlIHZlcnMuZ2V0
KCJkYXRlIikpCiAgICAgICAgICAgIGlmIHZlcnNbImVycm9yIl06CiAgICAg
ICAgICAgICAgICBwcmludCgiIGVycm9yOiAlcyIgJSB2ZXJzWyJlcnJvciJd
KQogICAgY21kc1sidmVyc2lvbiJdID0gY21kX3ZlcnNpb24KCiAgICAjIHdl
IG92ZXJyaWRlICJidWlsZF9weSIgaW4gYm90aCBkaXN0dXRpbHMgYW5kIHNl
dHVwdG9vbHMKICAgICMKICAgICMgbW9zdCBpbnZvY2F0aW9uIHBhdGh3YXlz
IGVuZCB1cCBydW5uaW5nIGJ1aWxkX3B5OgogICAgIyAgZGlzdHV0aWxzL2J1
aWxkIC0+IGJ1aWxkX3B5CiAgICAjICBkaXN0dXRpbHMvaW5zdGFsbCAtPiBk
aXN0dXRpbHMvYnVpbGQgLT4uLgogICAgIyAgc2V0dXB0b29scy9iZGlzdF93
aGVlbCAtPiBkaXN0dXRpbHMvaW5zdGFsbCAtPi4uCiAgICAjICBzZXR1cHRv
b2xzL2JkaXN0X2VnZyAtPiBkaXN0dXRpbHMvaW5zdGFsbF9saWIgLT4gYnVp
bGRfcHkKICAgICMgIHNldHVwdG9vbHMvaW5zdGFsbCAtPiBiZGlzdF9lZ2cg
LT4uLgogICAgIyAgc2V0dXB0b29scy9kZXZlbG9wIC0+ID8KICAgICMgIHBp
cCBpbnN0YWxsOgogICAgIyAgIGNvcGllcyBzb3VyY2UgdHJlZSB0byBhIHRl
bXBkaXIgYmVmb3JlIHJ1bm5pbmcgZWdnX2luZm8vZXRjCiAgICAjICAgaWYg
LmdpdCBpc24ndCBjb3BpZWQgdG9vLCAnZ2l0IGRlc2NyaWJlJyB3aWxsIGZh
aWwKICAgICMgICB0aGVuIGRvZXMgc2V0dXAucHkgYmRpc3Rfd2hlZWwsIG9y
IHNvbWV0aW1lcyBzZXR1cC5weSBpbnN0YWxsCiAgICAjICBzZXR1cC5weSBl
Z2dfaW5mbyAtPiA/CgogICAgIyB3ZSBvdmVycmlkZSBkaWZmZXJlbnQgImJ1
aWxkX3B5IiBjb21tYW5kcyBmb3IgYm90aCBlbnZpcm9ubWVudHMKICAgIGlm
ICdidWlsZF9weScgaW4gY21kczoKICAgICAgICBfYnVpbGRfcHkgPSBjbWRz
WydidWlsZF9weSddCiAgICBlbGlmICJzZXR1cHRvb2xzIiBpbiBzeXMubW9k
dWxlczoKICAgICAgICBmcm9tIHNldHVwdG9vbHMuY29tbWFuZC5idWlsZF9w
eSBpbXBvcnQgYnVpbGRfcHkgYXMgX2J1aWxkX3B5CiAgICBlbHNlOgogICAg
ICAgIGZyb20gZGlzdHV0aWxzLmNvbW1hbmQuYnVpbGRfcHkgaW1wb3J0IGJ1
aWxkX3B5IGFzIF9idWlsZF9weQoKICAgIGNsYXNzIGNtZF9idWlsZF9weShf
YnVpbGRfcHkpOgogICAgICAgIGRlZiBydW4oc2VsZik6CiAgICAgICAgICAg
IHJvb3QgPSBnZXRfcm9vdCgpCiAgICAgICAgICAgIGNmZyA9IGdldF9jb25m
aWdfZnJvbV9yb290KHJvb3QpCiAgICAgICAgICAgIHZlcnNpb25zID0gZ2V0
X3ZlcnNpb25zKCkKICAgICAgICAgICAgX2J1aWxkX3B5LnJ1bihzZWxmKQog
ICAgICAgICAgICAjIG5vdyBsb2NhdGUgX3ZlcnNpb24ucHkgaW4gdGhlIG5l
dyBidWlsZC8gZGlyZWN0b3J5IGFuZCByZXBsYWNlCiAgICAgICAgICAgICMg
aXQgd2l0aCBhbiB1cGRhdGVkIHZhbHVlCiAgICAgICAgICAgIGlmIGNmZy52
ZXJzaW9uZmlsZV9idWlsZDoKICAgICAgICAgICAgICAgIHRhcmdldF92ZXJz
aW9uZmlsZSA9IG9zLnBhdGguam9pbihzZWxmLmJ1aWxkX2xpYiwKICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBj
ZmcudmVyc2lvbmZpbGVfYnVpbGQpCiAgICAgICAgICAgICAgICBwcmludCgi
VVBEQVRJTkcgJXMiICUgdGFyZ2V0X3ZlcnNpb25maWxlKQogICAgICAgICAg
ICAgICAgd3JpdGVfdG9fdmVyc2lvbl9maWxlKHRhcmdldF92ZXJzaW9uZmls
ZSwgdmVyc2lvbnMpCiAgICBjbWRzWyJidWlsZF9weSJdID0gY21kX2J1aWxk
X3B5CgogICAgaWYgInNldHVwdG9vbHMiIGluIHN5cy5tb2R1bGVzOgogICAg
ICAgIGZyb20gc2V0dXB0b29scy5jb21tYW5kLmJ1aWxkX2V4dCBpbXBvcnQg
YnVpbGRfZXh0IGFzIF9idWlsZF9leHQKICAgIGVsc2U6CiAgICAgICAgZnJv
bSBkaXN0dXRpbHMuY29tbWFuZC5idWlsZF9leHQgaW1wb3J0IGJ1aWxkX2V4
dCBhcyBfYnVpbGRfZXh0CgogICAgY2xhc3MgY21kX2J1aWxkX2V4dChfYnVp
bGRfZXh0KToKICAgICAgICBkZWYgcnVuKHNlbGYpOgogICAgICAgICAgICBy
b290ID0gZ2V0X3Jvb3QoKQogICAgICAgICAgICBjZmcgPSBnZXRfY29uZmln
X2Zyb21fcm9vdChyb290KQogICAgICAgICAgICB2ZXJzaW9ucyA9IGdldF92
ZXJzaW9ucygpCiAgICAgICAgICAgIF9idWlsZF9leHQucnVuKHNlbGYpCiAg
ICAgICAgICAgIGlmIHNlbGYuaW5wbGFjZToKICAgICAgICAgICAgICAgICMg
YnVpbGRfZXh0IC0taW5wbGFjZSB3aWxsIG9ubHkgYnVpbGQgZXh0ZW5zaW9u
cyBpbgogICAgICAgICAgICAgICAgIyBidWlsZC9saWI8Li4+IGRpciB3aXRo
IG5vIF92ZXJzaW9uLnB5IHRvIHdyaXRlIHRvLgogICAgICAgICAgICAgICAg
IyBBcyBpbiBwbGFjZSBidWlsZHMgd2lsbCBhbHJlYWR5IGhhdmUgYSBfdmVy
c2lvbi5weQogICAgICAgICAgICAgICAgIyBpbiB0aGUgbW9kdWxlIGRpciwg
d2UgZG8gbm90IG5lZWQgdG8gd3JpdGUgb25lLgogICAgICAgICAgICAgICAg
cmV0dXJuCiAgICAgICAgICAgICMgbm93IGxvY2F0ZSBfdmVyc2lvbi5weSBp
biB0aGUgbmV3IGJ1aWxkLyBkaXJlY3RvcnkgYW5kIHJlcGxhY2UKICAgICAg
ICAgICAgIyBpdCB3aXRoIGFuIHVwZGF0ZWQgdmFsdWUKICAgICAgICAgICAg
dGFyZ2V0X3ZlcnNpb25maWxlID0gb3MucGF0aC5qb2luKHNlbGYuYnVpbGRf
bGliLAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgY2ZnLnZlcnNpb25maWxlX3NvdXJjZSkKICAgICAgICAgICAgcHJp
bnQoIlVQREFUSU5HICVzIiAlIHRhcmdldF92ZXJzaW9uZmlsZSkKICAgICAg
ICAgICAgd3JpdGVfdG9fdmVyc2lvbl9maWxlKHRhcmdldF92ZXJzaW9uZmls
ZSwgdmVyc2lvbnMpCiAgICBjbWRzWyJidWlsZF9leHQiXSA9IGNtZF9idWls
ZF9leHQKCiAgICBpZiAiY3hfRnJlZXplIiBpbiBzeXMubW9kdWxlczogICMg
Y3hfZnJlZXplIGVuYWJsZWQ/CiAgICAgICAgZnJvbSBjeF9GcmVlemUuZGlz
dCBpbXBvcnQgYnVpbGRfZXhlIGFzIF9idWlsZF9leGUKICAgICAgICAjIG5j
emVjenVsaW4gcmVwb3J0cyB0aGF0IHB5MmV4ZSB3b24ndCBsaWtlIHRoZSBw
ZXA0NDAtc3R5bGUgc3RyaW5nCiAgICAgICAgIyBhcyBGSUxFVkVSU0lPTiwg
YnV0IGl0IGNhbiBiZSB1c2VkIGZvciBQUk9EVUNUVkVSU0lPTiwgZS5nLgog
ICAgICAgICMgc2V0dXAoY29uc29sZT1bewogICAgICAgICMgICAidmVyc2lv
biI6IHZlcnNpb25lZXIuZ2V0X3ZlcnNpb24oKS5zcGxpdCgiKyIsIDEpWzBd
LCAjIEZJTEVWRVJTSU9OCiAgICAgICAgIyAgICJwcm9kdWN0X3ZlcnNpb24i
OiB2ZXJzaW9uZWVyLmdldF92ZXJzaW9uKCksCiAgICAgICAgIyAgIC4uLgoK
ICAgICAgICBjbGFzcyBjbWRfYnVpbGRfZXhlKF9idWlsZF9leGUpOgogICAg
ICAgICAgICBkZWYgcnVuKHNlbGYpOgogICAgICAgICAgICAgICAgcm9vdCA9
IGdldF9yb290KCkKICAgICAgICAgICAgICAgIGNmZyA9IGdldF9jb25maWdf
ZnJvbV9yb290KHJvb3QpCiAgICAgICAgICAgICAgICB2ZXJzaW9ucyA9IGdl
dF92ZXJzaW9ucygpCiAgICAgICAgICAgICAgICB0YXJnZXRfdmVyc2lvbmZp
bGUgPSBjZmcudmVyc2lvbmZpbGVfc291cmNlCiAgICAgICAgICAgICAgICBw
cmludCgiVVBEQVRJTkcgJXMiICUgdGFyZ2V0X3ZlcnNpb25maWxlKQogICAg
ICAgICAgICAgICAgd3JpdGVfdG9fdmVyc2lvbl9maWxlKHRhcmdldF92ZXJz
aW9uZmlsZSwgdmVyc2lvbnMpCgogICAgICAgICAgICAgICAgX2J1aWxkX2V4
ZS5ydW4oc2VsZikKICAgICAgICAgICAgICAgIG9zLnVubGluayh0YXJnZXRf
dmVyc2lvbmZpbGUpCiAgICAgICAgICAgICAgICB3aXRoIG9wZW4oY2ZnLnZl
cnNpb25maWxlX3NvdXJjZSwgInciKSBhcyBmOgogICAgICAgICAgICAgICAg
ICAgIExPTkcgPSBMT05HX1ZFUlNJT05fUFlbY2ZnLlZDU10KICAgICAgICAg
ICAgICAgICAgICBmLndyaXRlKExPTkcgJQogICAgICAgICAgICAgICAgICAg
ICAgICAgICAgeyJET0xMQVIiOiAiJCIsCiAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgIlNUWUxFIjogY2ZnLnN0eWxlLAogICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICJUQUdfUFJFRklYIjogY2ZnLnRhZ19wcmVmaXgsCiAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgIlBBUkVOVERJUl9QUkVGSVgi
OiBjZmcucGFyZW50ZGlyX3ByZWZpeCwKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAiVkVSU0lPTkZJTEVfU09VUkNFIjogY2ZnLnZlcnNpb25maWxl
X3NvdXJjZSwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICB9KQogICAg
ICAgIGNtZHNbImJ1aWxkX2V4ZSJdID0gY21kX2J1aWxkX2V4ZQogICAgICAg
IGRlbCBjbWRzWyJidWlsZF9weSJdCgogICAgaWYgJ3B5MmV4ZScgaW4gc3lz
Lm1vZHVsZXM6ICAjIHB5MmV4ZSBlbmFibGVkPwogICAgICAgIGZyb20gcHky
ZXhlLmRpc3R1dGlsc19idWlsZGV4ZSBpbXBvcnQgcHkyZXhlIGFzIF9weTJl
eGUKCiAgICAgICAgY2xhc3MgY21kX3B5MmV4ZShfcHkyZXhlKToKICAgICAg
ICAgICAgZGVmIHJ1bihzZWxmKToKICAgICAgICAgICAgICAgIHJvb3QgPSBn
ZXRfcm9vdCgpCiAgICAgICAgICAgICAgICBjZmcgPSBnZXRfY29uZmlnX2Zy
b21fcm9vdChyb290KQogICAgICAgICAgICAgICAgdmVyc2lvbnMgPSBnZXRf
dmVyc2lvbnMoKQogICAgICAgICAgICAgICAgdGFyZ2V0X3ZlcnNpb25maWxl
ID0gY2ZnLnZlcnNpb25maWxlX3NvdXJjZQogICAgICAgICAgICAgICAgcHJp
bnQoIlVQREFUSU5HICVzIiAlIHRhcmdldF92ZXJzaW9uZmlsZSkKICAgICAg
ICAgICAgICAgIHdyaXRlX3RvX3ZlcnNpb25fZmlsZSh0YXJnZXRfdmVyc2lv
bmZpbGUsIHZlcnNpb25zKQoKICAgICAgICAgICAgICAgIF9weTJleGUucnVu
KHNlbGYpCiAgICAgICAgICAgICAgICBvcy51bmxpbmsodGFyZ2V0X3ZlcnNp
b25maWxlKQogICAgICAgICAgICAgICAgd2l0aCBvcGVuKGNmZy52ZXJzaW9u
ZmlsZV9zb3VyY2UsICJ3IikgYXMgZjoKICAgICAgICAgICAgICAgICAgICBM
T05HID0gTE9OR19WRVJTSU9OX1BZW2NmZy5WQ1NdCiAgICAgICAgICAgICAg
ICAgICAgZi53cml0ZShMT05HICUKICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIHsiRE9MTEFSIjogIiQiLAogICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICJTVFlMRSI6IGNmZy5zdHlsZSwKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAiVEFHX1BSRUZJWCI6IGNmZy50YWdfcHJlZml4LAogICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICJQQVJFTlRESVJfUFJFRklYIjogY2Zn
LnBhcmVudGRpcl9wcmVmaXgsCiAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIlZFUlNJT05GSUxFX1NPVVJDRSI6IGNmZy52ZXJzaW9uZmlsZV9zb3Vy
Y2UsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgfSkKICAgICAgICBj
bWRzWyJweTJleGUiXSA9IGNtZF9weTJleGUKCiAgICAjIHdlIG92ZXJyaWRl
IGRpZmZlcmVudCAic2Rpc3QiIGNvbW1hbmRzIGZvciBib3RoIGVudmlyb25t
ZW50cwogICAgaWYgJ3NkaXN0JyBpbiBjbWRzOgogICAgICAgIF9zZGlzdCA9
IGNtZHNbJ3NkaXN0J10KICAgIGVsaWYgInNldHVwdG9vbHMiIGluIHN5cy5t
b2R1bGVzOgogICAgICAgIGZyb20gc2V0dXB0b29scy5jb21tYW5kLnNkaXN0
IGltcG9ydCBzZGlzdCBhcyBfc2Rpc3QKICAgIGVsc2U6CiAgICAgICAgZnJv
bSBkaXN0dXRpbHMuY29tbWFuZC5zZGlzdCBpbXBvcnQgc2Rpc3QgYXMgX3Nk
aXN0CgogICAgY2xhc3MgY21kX3NkaXN0KF9zZGlzdCk6CiAgICAgICAgZGVm
IHJ1bihzZWxmKToKICAgICAgICAgICAgdmVyc2lvbnMgPSBnZXRfdmVyc2lv
bnMoKQogICAgICAgICAgICBzZWxmLl92ZXJzaW9uZWVyX2dlbmVyYXRlZF92
ZXJzaW9ucyA9IHZlcnNpb25zCiAgICAgICAgICAgICMgdW5sZXNzIHdlIHVw
ZGF0ZSB0aGlzLCB0aGUgY29tbWFuZCB3aWxsIGtlZXAgdXNpbmcgdGhlIG9s
ZAogICAgICAgICAgICAjIHZlcnNpb24KICAgICAgICAgICAgc2VsZi5kaXN0
cmlidXRpb24ubWV0YWRhdGEudmVyc2lvbiA9IHZlcnNpb25zWyJ2ZXJzaW9u
Il0KICAgICAgICAgICAgcmV0dXJuIF9zZGlzdC5ydW4oc2VsZikKCiAgICAg
ICAgZGVmIG1ha2VfcmVsZWFzZV90cmVlKHNlbGYsIGJhc2VfZGlyLCBmaWxl
cyk6CiAgICAgICAgICAgIHJvb3QgPSBnZXRfcm9vdCgpCiAgICAgICAgICAg
IGNmZyA9IGdldF9jb25maWdfZnJvbV9yb290KHJvb3QpCiAgICAgICAgICAg
IF9zZGlzdC5tYWtlX3JlbGVhc2VfdHJlZShzZWxmLCBiYXNlX2RpciwgZmls
ZXMpCiAgICAgICAgICAgICMgbm93IGxvY2F0ZSBfdmVyc2lvbi5weSBpbiB0
aGUgbmV3IGJhc2VfZGlyIGRpcmVjdG9yeQogICAgICAgICAgICAjIChyZW1l
bWJlcmluZyB0aGF0IGl0IG1heSBiZSBhIGhhcmRsaW5rKSBhbmQgcmVwbGFj
ZSBpdCB3aXRoIGFuCiAgICAgICAgICAgICMgdXBkYXRlZCB2YWx1ZQogICAg
ICAgICAgICB0YXJnZXRfdmVyc2lvbmZpbGUgPSBvcy5wYXRoLmpvaW4oYmFz
ZV9kaXIsIGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UpCiAgICAgICAgICAgIHBy
aW50KCJVUERBVElORyAlcyIgJSB0YXJnZXRfdmVyc2lvbmZpbGUpCiAgICAg
ICAgICAgIHdyaXRlX3RvX3ZlcnNpb25fZmlsZSh0YXJnZXRfdmVyc2lvbmZp
bGUsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBzZWxmLl92
ZXJzaW9uZWVyX2dlbmVyYXRlZF92ZXJzaW9ucykKICAgIGNtZHNbInNkaXN0
Il0gPSBjbWRfc2Rpc3QKCiAgICByZXR1cm4gY21kcwoKCkNPTkZJR19FUlJP
UiA9ICIiIgpzZXR1cC5jZmcgaXMgbWlzc2luZyB0aGUgbmVjZXNzYXJ5IFZl
cnNpb25lZXIgY29uZmlndXJhdGlvbi4gWW91IG5lZWQKYSBzZWN0aW9uIGxp
a2U6CgogW3ZlcnNpb25lZXJdCiBWQ1MgPSBnaXQKIHN0eWxlID0gcGVwNDQw
CiB2ZXJzaW9uZmlsZV9zb3VyY2UgPSBzcmMvbXlwcm9qZWN0L192ZXJzaW9u
LnB5CiB2ZXJzaW9uZmlsZV9idWlsZCA9IG15cHJvamVjdC9fdmVyc2lvbi5w
eQogdGFnX3ByZWZpeCA9CiBwYXJlbnRkaXJfcHJlZml4ID0gbXlwcm9qZWN0
LQoKWW91IHdpbGwgYWxzbyBuZWVkIHRvIGVkaXQgeW91ciBzZXR1cC5weSB0
byB1c2UgdGhlIHJlc3VsdHM6CgogaW1wb3J0IHZlcnNpb25lZXIKIHNldHVw
KHZlcnNpb249dmVyc2lvbmVlci5nZXRfdmVyc2lvbigpLAogICAgICAgY21k
Y2xhc3M9dmVyc2lvbmVlci5nZXRfY21kY2xhc3MoKSwgLi4uKQoKUGxlYXNl
IHJlYWQgdGhlIGRvY3N0cmluZyBpbiAuL3ZlcnNpb25lZXIucHkgZm9yIGNv
bmZpZ3VyYXRpb24gaW5zdHJ1Y3Rpb25zLAplZGl0IHNldHVwLmNmZywgYW5k
IHJlLXJ1biB0aGUgaW5zdGFsbGVyIG9yICdweXRob24gdmVyc2lvbmVlci5w
eSBzZXR1cCcuCiIiIgoKU0FNUExFX0NPTkZJRyA9ICIiIgojIFNlZSB0aGUg
ZG9jc3RyaW5nIGluIHZlcnNpb25lZXIucHkgZm9yIGluc3RydWN0aW9ucy4g
Tm90ZSB0aGF0IHlvdSBtdXN0CiMgcmUtcnVuICd2ZXJzaW9uZWVyLnB5IHNl
dHVwJyBhZnRlciBjaGFuZ2luZyB0aGlzIHNlY3Rpb24sIGFuZCBjb21taXQg
dGhlCiMgcmVzdWx0aW5nIGZpbGVzLgoKW3ZlcnNpb25lZXJdCiNWQ1MgPSBn
aXQKI3N0eWxlID0gcGVwNDQwCiN2ZXJzaW9uZmlsZV9zb3VyY2UgPQojdmVy
c2lvbmZpbGVfYnVpbGQgPQojdGFnX3ByZWZpeCA9CiNwYXJlbnRkaXJfcHJl
Zml4ID0KCiIiIgoKSU5JVF9QWV9TTklQUEVUID0gIiIiCmZyb20gLl92ZXJz
aW9uIGltcG9ydCBnZXRfdmVyc2lvbnMKX192ZXJzaW9uX18gPSBnZXRfdmVy
c2lvbnMoKVsndmVyc2lvbiddCmRlbCBnZXRfdmVyc2lvbnMKIiIiCgoKZGVm
IGRvX3NldHVwKCk6CiAgICAiIiJEbyBtYWluIFZDUy1pbmRlcGVuZGVudCBz
ZXR1cCBmdW5jdGlvbiBmb3IgaW5zdGFsbGluZyBWZXJzaW9uZWVyLiIiIgog
ICAgcm9vdCA9IGdldF9yb290KCkKICAgIHRyeToKICAgICAgICBjZmcgPSBn
ZXRfY29uZmlnX2Zyb21fcm9vdChyb290KQogICAgZXhjZXB0IChFbnZpcm9u
bWVudEVycm9yLCBjb25maWdwYXJzZXIuTm9TZWN0aW9uRXJyb3IsCiAgICAg
ICAgICAgIGNvbmZpZ3BhcnNlci5Ob09wdGlvbkVycm9yKSBhcyBlOgogICAg
ICAgIGlmIGlzaW5zdGFuY2UoZSwgKEVudmlyb25tZW50RXJyb3IsIGNvbmZp
Z3BhcnNlci5Ob1NlY3Rpb25FcnJvcikpOgogICAgICAgICAgICBwcmludCgi
QWRkaW5nIHNhbXBsZSB2ZXJzaW9uZWVyIGNvbmZpZyB0byBzZXR1cC5jZmci
LAogICAgICAgICAgICAgICAgICBmaWxlPXN5cy5zdGRlcnIpCiAgICAgICAg
ICAgIHdpdGggb3Blbihvcy5wYXRoLmpvaW4ocm9vdCwgInNldHVwLmNmZyIp
LCAiYSIpIGFzIGY6CiAgICAgICAgICAgICAgICBmLndyaXRlKFNBTVBMRV9D
T05GSUcpCiAgICAgICAgcHJpbnQoQ09ORklHX0VSUk9SLCBmaWxlPXN5cy5z
dGRlcnIpCiAgICAgICAgcmV0dXJuIDEKCiAgICBwcmludCgiIGNyZWF0aW5n
ICVzIiAlIGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UpCiAgICB3aXRoIG9wZW4o
Y2ZnLnZlcnNpb25maWxlX3NvdXJjZSwgInciKSBhcyBmOgogICAgICAgIExP
TkcgPSBMT05HX1ZFUlNJT05fUFlbY2ZnLlZDU10KICAgICAgICBmLndyaXRl
KExPTkcgJSB7IkRPTExBUiI6ICIkIiwKICAgICAgICAgICAgICAgICAgICAg
ICAgIlNUWUxFIjogY2ZnLnN0eWxlLAogICAgICAgICAgICAgICAgICAgICAg
ICAiVEFHX1BSRUZJWCI6IGNmZy50YWdfcHJlZml4LAogICAgICAgICAgICAg
ICAgICAgICAgICAiUEFSRU5URElSX1BSRUZJWCI6IGNmZy5wYXJlbnRkaXJf
cHJlZml4LAogICAgICAgICAgICAgICAgICAgICAgICAiVkVSU0lPTkZJTEVf
U09VUkNFIjogY2ZnLnZlcnNpb25maWxlX3NvdXJjZSwKICAgICAgICAgICAg
ICAgICAgICAgICAgfSkKCiAgICBpcHkgPSBvcy5wYXRoLmpvaW4ob3MucGF0
aC5kaXJuYW1lKGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UpLAogICAgICAgICAg
ICAgICAgICAgICAgICJfX2luaXRfXy5weSIpCiAgICBpZiBvcy5wYXRoLmV4
aXN0cyhpcHkpOgogICAgICAgIHRyeToKICAgICAgICAgICAgd2l0aCBvcGVu
KGlweSwgInIiKSBhcyBmOgogICAgICAgICAgICAgICAgb2xkID0gZi5yZWFk
KCkKICAgICAgICBleGNlcHQgRW52aXJvbm1lbnRFcnJvcjoKICAgICAgICAg
ICAgb2xkID0gIiIKICAgICAgICBpZiBJTklUX1BZX1NOSVBQRVQgbm90IGlu
IG9sZDoKICAgICAgICAgICAgcHJpbnQoIiBhcHBlbmRpbmcgdG8gJXMiICUg
aXB5KQogICAgICAgICAgICB3aXRoIG9wZW4oaXB5LCAiYSIpIGFzIGY6CiAg
ICAgICAgICAgICAgICBmLndyaXRlKElOSVRfUFlfU05JUFBFVCkKICAgICAg
ICBlbHNlOgogICAgICAgICAgICBwcmludCgiICVzIHVubW9kaWZpZWQiICUg
aXB5KQogICAgZWxzZToKICAgICAgICBwcmludCgiICVzIGRvZXNuJ3QgZXhp
c3QsIG9rIiAlIGlweSkKICAgICAgICBpcHkgPSBOb25lCgogICAgIyBNYWtl
IHN1cmUgYm90aCB0aGUgdG9wLWxldmVsICJ2ZXJzaW9uZWVyLnB5IiBhbmQg
dmVyc2lvbmZpbGVfc291cmNlCiAgICAjIChQS0cvX3ZlcnNpb24ucHksIHVz
ZWQgYnkgcnVudGltZSBjb2RlKSBhcmUgaW4gTUFOSUZFU1QuaW4sIHNvCiAg
ICAjIHRoZXknbGwgYmUgY29waWVkIGludG8gc291cmNlIGRpc3RyaWJ1dGlv
bnMuIFBpcCB3b24ndCBiZSBhYmxlIHRvCiAgICAjIGluc3RhbGwgdGhlIHBh
Y2thZ2Ugd2l0aG91dCB0aGlzLgogICAgbWFuaWZlc3RfaW4gPSBvcy5wYXRo
LmpvaW4ocm9vdCwgIk1BTklGRVNULmluIikKICAgIHNpbXBsZV9pbmNsdWRl
cyA9IHNldCgpCiAgICB0cnk6CiAgICAgICAgd2l0aCBvcGVuKG1hbmlmZXN0
X2luLCAiciIpIGFzIGY6CiAgICAgICAgICAgIGZvciBsaW5lIGluIGY6CiAg
ICAgICAgICAgICAgICBpZiBsaW5lLnN0YXJ0c3dpdGgoImluY2x1ZGUgIik6
CiAgICAgICAgICAgICAgICAgICAgZm9yIGluY2x1ZGUgaW4gbGluZS5zcGxp
dCgpWzE6XToKICAgICAgICAgICAgICAgICAgICAgICAgc2ltcGxlX2luY2x1
ZGVzLmFkZChpbmNsdWRlKQogICAgZXhjZXB0IEVudmlyb25tZW50RXJyb3I6
CiAgICAgICAgcGFzcwogICAgIyBUaGF0IGRvZXNuJ3QgY292ZXIgZXZlcnl0
aGluZyBNQU5JRkVTVC5pbiBjYW4gZG8KICAgICMgKGh0dHA6Ly9kb2NzLnB5
dGhvbi5vcmcvMi9kaXN0dXRpbHMvc291cmNlZGlzdC5odG1sI2NvbW1hbmRz
KSwgc28KICAgICMgaXQgbWlnaHQgZ2l2ZSBzb21lIGZhbHNlIG5lZ2F0aXZl
cy4gQXBwZW5kaW5nIHJlZHVuZGFudCAnaW5jbHVkZScKICAgICMgbGluZXMg
aXMgc2FmZSwgdGhvdWdoLgogICAgaWYgInZlcnNpb25lZXIucHkiIG5vdCBp
biBzaW1wbGVfaW5jbHVkZXM6CiAgICAgICAgcHJpbnQoIiBhcHBlbmRpbmcg
J3ZlcnNpb25lZXIucHknIHRvIE1BTklGRVNULmluIikKICAgICAgICB3aXRo
IG9wZW4obWFuaWZlc3RfaW4sICJhIikgYXMgZjoKICAgICAgICAgICAgZi53
cml0ZSgiaW5jbHVkZSB2ZXJzaW9uZWVyLnB5XG4iKQogICAgZWxzZToKICAg
ICAgICBwcmludCgiICd2ZXJzaW9uZWVyLnB5JyBhbHJlYWR5IGluIE1BTklG
RVNULmluIikKICAgIGlmIGNmZy52ZXJzaW9uZmlsZV9zb3VyY2Ugbm90IGlu
IHNpbXBsZV9pbmNsdWRlczoKICAgICAgICBwcmludCgiIGFwcGVuZGluZyB2
ZXJzaW9uZmlsZV9zb3VyY2UgKCclcycpIHRvIE1BTklGRVNULmluIiAlCiAg
ICAgICAgICAgICAgY2ZnLnZlcnNpb25maWxlX3NvdXJjZSkKICAgICAgICB3
aXRoIG9wZW4obWFuaWZlc3RfaW4sICJhIikgYXMgZjoKICAgICAgICAgICAg
Zi53cml0ZSgiaW5jbHVkZSAlc1xuIiAlIGNmZy52ZXJzaW9uZmlsZV9zb3Vy
Y2UpCiAgICBlbHNlOgogICAgICAgIHByaW50KCIgdmVyc2lvbmZpbGVfc291
cmNlIGFscmVhZHkgaW4gTUFOSUZFU1QuaW4iKQoKICAgICMgTWFrZSBWQ1Mt
c3BlY2lmaWMgY2hhbmdlcy4gRm9yIGdpdCwgdGhpcyBtZWFucyBjcmVhdGlu
Zy9jaGFuZ2luZwogICAgIyAuZ2l0YXR0cmlidXRlcyB0byBtYXJrIF92ZXJz
aW9uLnB5IGZvciBleHBvcnQtc3Vic3Qga2V5d29yZAogICAgIyBzdWJzdGl0
dXRpb24uCiAgICBkb192Y3NfaW5zdGFsbChtYW5pZmVzdF9pbiwgY2ZnLnZl
cnNpb25maWxlX3NvdXJjZSwgaXB5KQogICAgcmV0dXJuIDAKCgpkZWYgc2Nh
bl9zZXR1cF9weSgpOgogICAgIiIiVmFsaWRhdGUgdGhlIGNvbnRlbnRzIG9m
IHNldHVwLnB5IGFnYWluc3QgVmVyc2lvbmVlcidzIGV4cGVjdGF0aW9ucy4i
IiIKICAgIGZvdW5kID0gc2V0KCkKICAgIHNldHRlcnMgPSBGYWxzZQogICAg
ZXJyb3JzID0gMAogICAgd2l0aCBvcGVuKCJzZXR1cC5weSIsICJyIikgYXMg
ZjoKICAgICAgICBmb3IgbGluZSBpbiBmLnJlYWRsaW5lcygpOgogICAgICAg
ICAgICBpZiAiaW1wb3J0IHZlcnNpb25lZXIiIGluIGxpbmU6CiAgICAgICAg
ICAgICAgICBmb3VuZC5hZGQoImltcG9ydCIpCiAgICAgICAgICAgIGlmICJ2
ZXJzaW9uZWVyLmdldF9jbWRjbGFzcygpIiBpbiBsaW5lOgogICAgICAgICAg
ICAgICAgZm91bmQuYWRkKCJjbWRjbGFzcyIpCiAgICAgICAgICAgIGlmICJ2
ZXJzaW9uZWVyLmdldF92ZXJzaW9uKCkiIGluIGxpbmU6CiAgICAgICAgICAg
ICAgICBmb3VuZC5hZGQoImdldF92ZXJzaW9uIikKICAgICAgICAgICAgaWYg
InZlcnNpb25lZXIuVkNTIiBpbiBsaW5lOgogICAgICAgICAgICAgICAgc2V0
dGVycyA9IFRydWUKICAgICAgICAgICAgaWYgInZlcnNpb25lZXIudmVyc2lv
bmZpbGVfc291cmNlIiBpbiBsaW5lOgogICAgICAgICAgICAgICAgc2V0dGVy
cyA9IFRydWUKICAgIGlmIGxlbihmb3VuZCkgIT0gMzoKICAgICAgICBwcmlu
dCgiIikKICAgICAgICBwcmludCgiWW91ciBzZXR1cC5weSBhcHBlYXJzIHRv
IGJlIG1pc3Npbmcgc29tZSBpbXBvcnRhbnQgaXRlbXMiKQogICAgICAgIHBy
aW50KCIoYnV0IEkgbWlnaHQgYmUgd3JvbmcpLiBQbGVhc2UgbWFrZSBzdXJl
IGl0IGhhcyBzb21ldGhpbmciKQogICAgICAgIHByaW50KCJyb3VnaGx5IGxp
a2UgdGhlIGZvbGxvd2luZzoiKQogICAgICAgIHByaW50KCIiKQogICAgICAg
IHByaW50KCIgaW1wb3J0IHZlcnNpb25lZXIiKQogICAgICAgIHByaW50KCIg
c2V0dXAoIHZlcnNpb249dmVyc2lvbmVlci5nZXRfdmVyc2lvbigpLCIpCiAg
ICAgICAgcHJpbnQoIiAgICAgICAgY21kY2xhc3M9dmVyc2lvbmVlci5nZXRf
Y21kY2xhc3MoKSwgIC4uLikiKQogICAgICAgIHByaW50KCIiKQogICAgICAg
IGVycm9ycyArPSAxCiAgICBpZiBzZXR0ZXJzOgogICAgICAgIHByaW50KCJZ
b3Ugc2hvdWxkIHJlbW92ZSBsaW5lcyBsaWtlICd2ZXJzaW9uZWVyLlZDUyA9
ICcgYW5kIikKICAgICAgICBwcmludCgiJ3ZlcnNpb25lZXIudmVyc2lvbmZp
bGVfc291cmNlID0gJyAuIFRoaXMgY29uZmlndXJhdGlvbiIpCiAgICAgICAg
cHJpbnQoIm5vdyBsaXZlcyBpbiBzZXR1cC5jZmcsIGFuZCBzaG91bGQgYmUg
cmVtb3ZlZCBmcm9tIHNldHVwLnB5IikKICAgICAgICBwcmludCgiIikKICAg
ICAgICBlcnJvcnMgKz0gMQogICAgcmV0dXJuIGVycm9ycwoKCmlmIF9fbmFt
ZV9fID09ICJfX21haW5fXyI6CiAgICBjbWQgPSBzeXMuYXJndlsxXQogICAg
aWYgY21kID09ICJzZXR1cCI6CiAgICAgICAgZXJyb3JzID0gZG9fc2V0dXAo
KQogICAgICAgIGVycm9ycyArPSBzY2FuX3NldHVwX3B5KCkKICAgICAgICBp
ZiBlcnJvcnM6CiAgICAgICAgICAgIHN5cy5leGl0KDEpCg==

"""
newver = "0.19"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
